#include "cps.h"

/*==========================================================
 Darkstalkers: The Night Warriors - All-in-One Driver 1.63
 Added Battle Time cheat - Mike_Haggar_99@hotmail.com
 Rom renaming by Treble Winner - mamediff.log - Added dstlk
 Cheat engine source by HyperYagami
 Added encrypted Asia driver (LoopMaster)
==========================================================*/

static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nCpsCount=0,nDrvCount=0;
  // Inputs common to all CPS2 Fighter Style games
  nCpsCount=sizeof(CpsFsi)/sizeof(CpsFsi[0]);
  if (i<nCpsCount) { if (pii!=NULL) *pii=CpsFsi[i];  return 0; }
  i-=nCpsCount;

  // HyperYagami: cheats
  SETUP_THE_CHEAT_LIST

  return 1; // Out of range
}

static int DrvScode(unsigned int n)
{
  if (n<=0x2f) return 2;  return 1;
}

static int DrvInit()
{
  int nRet=0; int i=0; unsigned char *pqs=NULL;

  Cps=2;
  nCpsRomLen=  8*0x080000;
  nCpsCodeLen= 2*0x080000;
  nCpsGfxLen=   0x1400000;
  nCpsZRomLen= 2*0x020000;
  nCpsQSamLen= 2*0x200000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms (as they are on the roms) for CpsRom
  for (i=0;i<8;i++)
  { nRet=BurnLoadRom(CpsRom+0x080000*i,2+i,1); if (nRet!=0) return 1; }

  // Make decrypted rom
  memcpy(CpsCode,CpsRom,nCpsCodeLen);
  nRet=BurnXorRom(CpsCode         ,0,1); if (nRet!=0) return 1;
  nRet=BurnXorRom(CpsCode+0x080000,1,1); if (nRet!=0) return 1;

  // Load graphics roms
  nRet=Cps2LoadTiles(CpsGfx           ,10);
  nRet=Cps2LoadTiles(CpsGfx+ 0x1000000,14);

  // Load Z80 Roms
  nRet=BurnLoadRom(CpsZRom         ,18,1);
  nRet=BurnLoadRom(CpsZRom+ 0x20000,19,1);

  // Load Q Sample Roms
  pqs=(unsigned char *)CpsQSam;
  nRet=BurnLoadRom(pqs         ,20,1);
  nRet=BurnLoadRom(pqs+0x200000,21,1);
  BurnByteswap(pqs,nCpsQSamLen);
  BurnScode=DrvScode;

ConstructCheatList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int DrvExit()
{

DestroyCheatList();

  CpsRunExit();
  BurnScode=NULL;
  CpsExit();
  nCpsQSamLen=0;
  nCpsZRomLen=0;
  nCpsGfxLen=0;
  nCpsCodeLen=0;
  nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsAllThree(); // Process all three punches and kicks
  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps2Frame();
  return 0;
}

/*===================================
 Vampire: The Night Warriors (Japan)
===================================*/

static int VampjZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="dstlk.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="vampj.zip"; return 0; }
  return 1;
}

static struct StdRomInfo VampjRomDesc[]=
{
  {"vamjx.03a",0x80000,0x2549f7bc, 0x10},
  {"vamjx.04b",0x80000,0xbb5a30a5, 0x10},

  {"vamj.03a" ,0x80000,0xf55d3722, 0x10},
  {"vamj.04b" ,0x80000,0x4d9c43c4, 0x10},
  {"vamj.05a" ,0x80000,0x6c497e92, 0x10},
  {"vamj.06a" ,0x80000,0xf1bbecb6, 0x10},
  {"vamj.07a" ,0x80000,0x1067ad84, 0x10},
  {"vamj.08a" ,0x80000,0x4b89f41f, 0x10},
  {"vamj.09a" ,0x80000,0xfc0a4aac, 0x10},
  {"vamj.10a" ,0x80000,0x9270c26b, 0x10},

  {"vam.13"  ,0x400000,0xc51baf99,    1},
  {"vam.15"  ,0x400000,0x3ce83c77,    1},
  {"vam.17"  ,0x400000,0x4f2408e0,    1},
  {"vam.19"  ,0x400000,0x9ff60250,    1},
  {"vam.14"  ,0x100000,0xbd87243c,    1},
  {"vam.16"  ,0x100000,0xafec855f,    1},
  {"vam.18"  ,0x100000,0x3a033625,    1},
  {"vam.20"  ,0x100000,0x2bff6a89,    1},

  {"vam.01"  ,0x020000,0x64b685d5,    2},
  {"vam.02"  ,0x020000,0xcf7c97c7,    2},

  {"vam.11"  ,0x200000,0x4a39deb2,    2},
  {"vam.12"  ,0x200000,0x1a3e5c03,    2},

};

STD_ROM_PICK(Vampj) STD_ROM_FN(Vampj)

struct BurnDriver BurnDrvCpsVampj=
{
  {"vampj" ,"Vampire: The Night Warriors (Japan)","","Capcom","CPS2","1994","dstlk"},
  1,2,HARDWARE_CAPCOM_CPS2,
  VampjZipName, VampjRomInfo, VampjRomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*=======================================
 Vampire: The Night Warriors (Japan alt)
=======================================*/

static int VampjaZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="dstlk.zip";  return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="vampja.zip"; return 0; }
  return 1;
}

static struct StdRomInfo VampjaRomDesc[]=
{
  {"vamjx.03a",0x80000,0x2549f7bc, 0x10},
  {"vamjx.04a",0x80000,0xfe64a5cf, 0x10},

  {"vamj.03a" ,0x80000,0xf55d3722, 0x10},
  {"vamj.04a" ,0x80000,0xfdcbdae3, 0x10},
  {"vamj.05a" ,0x80000,0x6c497e92, 0x10},
  {"vamj.06a" ,0x80000,0xf1bbecb6, 0x10},
  {"vamj.07a" ,0x80000,0x1067ad84, 0x10},
  {"vamj.08a" ,0x80000,0x4b89f41f, 0x10},
  {"vamj.09a" ,0x80000,0xfc0a4aac, 0x10},
  {"vamj.10a" ,0x80000,0x9270c26b, 0x10},

  {"vam.13"  ,0x400000,0xc51baf99,    1},
  {"vam.15"  ,0x400000,0x3ce83c77,    1},
  {"vam.17"  ,0x400000,0x4f2408e0,    1},
  {"vam.19"  ,0x400000,0x9ff60250,    1},
  {"vam.14"  ,0x100000,0xbd87243c,    1},
  {"vam.16"  ,0x100000,0xafec855f,    1},
  {"vam.18"  ,0x100000,0x3a033625,    1},
  {"vam.20"  ,0x100000,0x2bff6a89,    1},

  {"vam.01"  ,0x020000,0x64b685d5,    2},
  {"vam.02"  ,0x020000,0xcf7c97c7,    2},

  {"vam.11"  ,0x200000,0x4a39deb2,    2},
  {"vam.12"  ,0x200000,0x1a3e5c03,    2},

};

STD_ROM_PICK(Vampja) STD_ROM_FN(Vampja)

struct BurnDriver BurnDrvCpsVampja=
{
  {"vampja" ,"Vampire: The Night Warriors (Japan alt)","","Capcom","CPS2","1994","dstlk"},
  1,2,HARDWARE_CAPCOM_CPS2,
  VampjaZipName, VampjaRomInfo, VampjaRomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*======================================
 Vampire: The Night Warriors (Japan r1)
======================================*/

static int Vampjr1ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="dstlk.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="vampjr1.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Vampjr1RomDesc[]=
{
  {"vamjx.03",0x80000,0xf6fe646a, 0x10},
  {"vamjx.04",0x80000,0x566014e5, 0x10},

  {"vamj.03" ,0x80000,0x8895bf77, 0x10},
  {"vamj.04" ,0x80000,0x5027db3d, 0x10},
  {"vamj.05" ,0x80000,0x97c66fdb, 0x10},
  {"vamj.06" ,0x80000,0x9b4c3426, 0x10},
  {"vamj.07" ,0x80000,0x303bc4fd, 0x10},
  {"vamj.08" ,0x80000,0x3dea3646, 0x10},
  {"vamj.09" ,0x80000,0xc119a827, 0x10},
  {"vamj.10" ,0x80000,0x46593b79, 0x10},

  {"vam.13"  ,0x400000,0xc51baf99,    1},
  {"vam.15"  ,0x400000,0x3ce83c77,    1},
  {"vam.17"  ,0x400000,0x4f2408e0,    1},
  {"vam.19"  ,0x400000,0x9ff60250,    1},
  {"vam.14"  ,0x100000,0xbd87243c,    1},
  {"vam.16"  ,0x100000,0xafec855f,    1},
  {"vam.18"  ,0x100000,0x3a033625,    1},
  {"vam.20"  ,0x100000,0x2bff6a89,    1},

  {"vam.01"  ,0x020000,0x64b685d5,    2},
  {"vam.02"  ,0x020000,0xcf7c97c7,    2},

  {"vam.11"  ,0x200000,0x4a39deb2,    2},
  {"vam.12"  ,0x200000,0x1a3e5c03,    2},

};

STD_ROM_PICK(Vampjr1) STD_ROM_FN(Vampjr1)

struct BurnDriver BurnDrvCpsVampjr1=
{
  {"vampjr1" ,"Vampire: The Night Warriors (Japan r1)","","Capcom","CPS2","1994","dstlk"},
  1,2,HARDWARE_CAPCOM_CPS2,
  Vampjr1ZipName, Vampjr1RomInfo, Vampjr1RomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*======================================
 Dalkstalkers: The Night Warriors (USA)
======================================*/

static int DstlkZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="dstlk.zip"; return 0; }
  return 1;
}

static struct StdRomInfo DstlkRomDesc[]=
{
  {"vamux.03b",0x80000,0x15ff2d3e, 0x10},
  {"vamux.04b",0x80000,0x4cf62f1b, 0x10},

  {"vamu.03b" ,0x80000,0x68a6343f, 0x10},
  {"vamu.04b" ,0x80000,0x58161453, 0x10},
  {"vamu.05b" ,0x80000,0xdfc038b8, 0x10},
  {"vamu.06b" ,0x80000,0xc3842c89, 0x10},
  {"vamu.07b" ,0x80000,0x25b60b6e, 0x10},
  {"vamu.08b" ,0x80000,0x2113c596, 0x10},
  {"vamu.09b" ,0x80000,0x2d1e9ae5, 0x10},
  {"vamu.10b" ,0x80000,0x81145622, 0x10},

  {"vam.13"  ,0x400000,0xc51baf99,    1},
  {"vam.15"  ,0x400000,0x3ce83c77,    1},
  {"vam.17"  ,0x400000,0x4f2408e0,    1},
  {"vam.19"  ,0x400000,0x9ff60250,    1},
  {"vam.14"  ,0x100000,0xbd87243c,    1},
  {"vam.16"  ,0x100000,0xafec855f,    1},
  {"vam.18"  ,0x100000,0x3a033625,    1},
  {"vam.20"  ,0x100000,0x2bff6a89,    1},

  {"vam.01"  ,0x020000,0x64b685d5,    2},
  {"vam.02"  ,0x020000,0xcf7c97c7,    2},

  {"vam.11"  ,0x200000,0x4a39deb2,    2},
  {"vam.12"  ,0x200000,0x1a3e5c03,    2},

};

STD_ROM_PICK(Dstlk) STD_ROM_FN(Dstlk)

struct BurnDriver BurnDrvCpsDstlk=
{
  {"dstlk" ,"Darkstalkers: The Night Warriors (USA)","","Capcom","CPS2","1994",NULL},
  1,2,HARDWARE_CAPCOM_CPS2,
  DstlkZipName, DstlkRomInfo, DstlkRomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*=========================================
 Dalkstalkers: The Night Warriors (USA r1)
=========================================*/

static int Dstlkr1ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="dstlk.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="dstlkr1.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Dstlkr1RomDesc[]=
{
  {"vamux.03a",0x80000,0xdb0837f5, 0x10},
  {"vamux.04a",0x80000,0x8a924055, 0x10},

  {"vamu.03a" ,0x80000,0x628899f9, 0x10},
  {"vamu.04a" ,0x80000,0x696d9b25, 0x10},
  {"vamu.05a" ,0x80000,0x673ed50a, 0x10},
  {"vamu.06a" ,0x80000,0xf2377be7, 0x10},
  {"vamu.07a" ,0x80000,0xd8f498c4, 0x10},
  {"vamu.08a" ,0x80000,0xe6a8a1a0, 0x10},
  {"vamu.09a" ,0x80000,0x8dd55b24, 0x10},
  {"vamu.10a" ,0x80000,0xc1a3d9be, 0x10},

  {"vam.13"  ,0x400000,0xc51baf99,    1},
  {"vam.15"  ,0x400000,0x3ce83c77,    1},
  {"vam.17"  ,0x400000,0x4f2408e0,    1},
  {"vam.19"  ,0x400000,0x9ff60250,    1},
  {"vam.14"  ,0x100000,0xbd87243c,    1},
  {"vam.16"  ,0x100000,0xafec855f,    1},
  {"vam.18"  ,0x100000,0x3a033625,    1},
  {"vam.20"  ,0x100000,0x2bff6a89,    1},

  {"vam.01"  ,0x020000,0x64b685d5,    2},
  {"vam.02"  ,0x020000,0xcf7c97c7,    2},

  {"vam.11"  ,0x200000,0x4a39deb2,    2},
  {"vam.12"  ,0x200000,0x1a3e5c03,    2},

};

STD_ROM_PICK(Dstlkr1) STD_ROM_FN(Dstlkr1)

struct BurnDriver BurnDrvCpsDstlkr1=
{
  {"dstlkr1" ,"Darkstalkers: The Night Warriors (USA r1)","","Capcom","CPS2","1994","dstlk"},
  1,2,HARDWARE_CAPCOM_CPS2,
  Dstlkr1ZipName, Dstlkr1RomInfo, Dstlkr1RomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

/*======================================
 Darkstalkers: The Night Warriors (Asia)
======================================*/

static int DstlkaZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="dstlk.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="dstlka.zip"; return 0; }
  return 1;
}

static struct StdRomInfo DstlkaRomDesc[]=
{
  {"vamax.03a",0x80000,0x9b7d6254, 0x10},
  {"vamax.04a",0x80000,0xd9ec3a82, 0x10},

  {"vama.03a" ,0x80000,0x294e0bec, 0x10},
  {"vama.04a" ,0x80000,0xbc18e128, 0x10},
  {"vama.05a" ,0x80000,0xe709fa59, 0x10},
  {"vama.06a" ,0x80000,0x55e4d387, 0x10},
  {"vama.07a" ,0x80000,0x24e8f981, 0x10},
  {"vama.08a" ,0x80000,0x743f3a8e, 0x10},
  {"vama.09a" ,0x80000,0x67fa5573, 0x10},
  {"vama.10a" ,0x80000,0x5e03d747, 0x10},

  {"vam.13"  ,0x400000,0xc51baf99,    1},
  {"vam.15"  ,0x400000,0x3ce83c77,    1},
  {"vam.17"  ,0x400000,0x4f2408e0,    1},
  {"vam.19"  ,0x400000,0x9ff60250,    1},
  {"vam.14"  ,0x100000,0xbd87243c,    1},
  {"vam.16"  ,0x100000,0xafec855f,    1},
  {"vam.18"  ,0x100000,0x3a033625,    1},
  {"vam.20"  ,0x100000,0x2bff6a89,    1},

  {"vam.01"  ,0x020000,0x64b685d5,    2},
  {"vam.02"  ,0x020000,0xcf7c97c7,    2},

  {"vam.11"  ,0x200000,0x4a39deb2,    2},
  {"vam.12"  ,0x200000,0x1a3e5c03,    2},

};

STD_ROM_PICK(Dstlka) STD_ROM_FN(Dstlka)

struct BurnDriver BurnDrvCpsDstlka=
{
  {"dstlka" ,"Darkstalkers: The Night Warriors (Asia)","","Capcom","CPS2","1994","dstlk"},
  1,2,HARDWARE_CAPCOM_CPS2,
  DstlkaZipName, DstlkaRomInfo, DstlkaRomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
