#include "cps.h"
// Quiz Tonosama no Yabou 2 Zenkoku-ban - All-in-One Driver 1.11 by Mike_Haggar_99@hotmail.com
// Load menu display adjustment by LoopMaster
// Cheat engine source by HyperYagami
// Rdname button by Bigfool

static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
  {"P1 Start"      , 0, CpsInp018+4, "p1 start"},
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"},
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"},
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"},
  {"P1 Right"      , 0, CpsInp001+0, "p1 right"},
  {"P1 Answer 1"   , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Answer 2"   , 0, CpsInp001+5, "p1 fire 2"},
  {"P1 Answer 3"   , 0, CpsInp001+6, "p1 fire 3"},
  {"P1 Answer 4"   , 0, CpsInp001+7, "p1 fire 4"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
  {"P2 Start"      , 0, CpsInp018+5, "p2 start"},
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"},
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"},
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"},
  {"P2 Right"      , 0, CpsInp000+0, "p2 right"},
  {"P2 Answer 1"   , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Answer 2"   , 0, CpsInp000+5, "p2 fire 2"},
  {"P2 Answer 3"   , 0, CpsInp000+6, "p2 fire 3"},
  {"P2 Answer 4"   , 0, CpsInp000+7, "p2 fire 4"},

  {"Reset"         , 0, &CpsReset,   "reset"},
  {"Diagnostic"    , 0, CpsInp018+6, "diag"},
  {"Service"       , 0, CpsInp018+2, "service"},
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n<=0x22) return 2;
  if (n>=0xa8 && n<=0xc8) return 2;
  return 1;
}

static int DrvInit()
{
  int nRet=0;
  Cps=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 8*0x080000;
  nCpsZRomLen=  0x008000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080001,4,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,5,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0001,6,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x0c0000,7,2); if (nRet!=0) return 1;
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTiles(CpsGfx         ,8);
  CpsLoadTiles(CpsGfx+0x200000,12);

  nCpsLcReg=0x66; // Layer control register is at 0x66
  CpsLayEn[1]=0x02;
  CpsLayEn[2]=0x04;
  CpsLayEn[3]=0x08;

  // Protection enable code by KEV
  CpsMProt[0]=0x40;
  CpsMProt[1]=0x42;
  CpsMProt[2]=0x44;
  CpsMProt[3]=0x46;

  MaskAddr[0]=0x68;
  MaskAddr[1]=0x6a;
  MaskAddr[2]=0x6c;
  MaskAddr[3]=0x6e;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,16,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,17,1);
  nRet=BurnLoadRom(CpsAd+0x20000,18,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

static int DrvExit()
{
  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

//============================================
//Quiz Tonosama no Yabou 2 Zenkoku-ban (Japan)
//============================================

// Count possible zip names and (if pszName!=NULL) return them
static int Qtono2ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="qtono2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="qtfix2.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo Qtono2RomDesc[]=
{
  {"tn2j-30.11e" ,0x20000,0x9226eb5e,0x10}, // 0 even 68000 code
  {"tn2j-37.11f" ,0x20000,0xd1d30da1,0x10}, // 1 odd
  {"tn2j-31.12e" ,0x20000,0x015e6a8a,0x10}, // 2 even 68000 code
  {"tn2j-38.12f" ,0x20000,0x1f139bcc,0x10}, // 3 odd
  {"tn2j-28.9e" ,0x20000,0x86d27f71,0x10}, // 4 even 68000 code
  {"tn2j-35.9f" ,0x20000,0x7a1ab87d,0x10}, // 5 odd
  {"tn2j-29.10e" ,0x20000,0x9c384e99,0x10}, // 6 even 68000 code
  {"tn2j-36.10f" ,0x20000,0x4c4b2a0a,0x10}, // 7 odd

  // graphics:
  {"tn2-02m.4a",0x80000,0xf2016a34,   1}, // 8
  {"tn2-04m.6a",0x80000,0x094e0fb1,   1},
  {"tn2-01m.3a",0x80000,0xcb950cf9,   1},
  {"tn2-03m.5a",0x80000,0x18a5bf59,   1},
  {"tn2-11m.4c",0x80000,0xd0edd30b,   1}, // 12
  {"tn2-13m.6c",0x80000,0x426621c3,   1},
  {"tn2-10m.3c",0x80000,0xa34ece70,   1},
  {"tn2-12m.5c",0x80000,0xe04ff2f4,   1},

  // z80 rom
  {"tn2j-09.12a" ,0x08000,0x6d8edcef,   1}, // 16
  // samples
  {"tn2j-18.11c" ,0x20000,0xa40bf9a7,   1},
  {"tn2j-19.12c" ,0x20000,0x5b3b931e,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Qtono2) STD_ROM_FN(Qtono2)

struct BurnDriver BurnDrvCpsQtono2=
{
  {"qtono2","Quiz Tonosama no Yabou 2 Zenkoku-ban (Japan)","","Capcom","CPS1","1995",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  Qtono2ZipName,Qtono2RomInfo,Qtono2RomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
