#include "cps.h"
//Street Fighter II - The World Warrior - All-in-One Driver 1.81 by Mike_Haggar_99@hotmail.com
// Load menu display adjustment by LoopMaster
// Thanks to Treble_Winner for the Init13 Fix
// Cheat engine source by HyperYagami
// Fixed All three kicks button by Bigfool


static unsigned char AllThree1[4]={0,0,0,0};

static int CpsFsAllThree1()
{
 // Process all three punches and kicks
 if (AllThree1[0]) { CpsFsi[ 6].pVal[0]=1; CpsFsi[ 7].pVal[0]=1; CpsFsi[ 8].pVal[0]=1; }
 if (AllThree1[1]) { CpsInp177[0]=1; CpsInp177[1]=1; CpsInp177[2]=1; }
 if (AllThree1[2]) { CpsFsi[20].pVal[0]=1; CpsFsi[21].pVal[0]=1; CpsFsi[22].pVal[0]=1; }
 if (AllThree1[3]) { CpsInp177[4]=1; CpsInp177[5]=1; CpsInp177[6]=1; }
 if (AllThree1[4]) { CpsInp1fd[4]=1; CpsInp1fd[5]=1; CpsInp1fd[6]=1; }
 if (AllThree1[5]) { CpsInp1fd[4]=1; CpsInp1fd[5]=1; CpsInp1fd[6]=1; }
 return 0;
}
static struct BurnInputInfo DrvInputList[]=
{
{"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
{"P1 Start"      , 0, CpsInp018+4, "p1 start"},
{"P1 Up"         , 0, CpsInp001+3, "p1 up"},
{"P1 Down"       , 0, CpsInp001+2, "p1 down"},
{"P1 Left"       , 0, CpsInp001+1, "p1 left"},
{"P1 Right"      , 0, CpsInp001+0, "p1 right"},
{"P1 Low Punch"  , 0, CpsInp001+4, "p1 fire 4"},
{"P1 Mid Punch"  , 0, CpsInp001+5, "p1 fire 5"},
{"P1 High Punch" , 0, CpsInp001+6, "p1 fire 6"},
{"P1 Low Kick"   , 0, CpsInp177+0, "p1 fire 1"},
{"P1 Mid Kick"   , 0, CpsInp177+1, "p1 fire 2"},
{"P1 High Kick"  , 0, CpsInp177+2, "p1 fire 3"},
{"P1 All Punches", 0, AllThree1+0 , ""},
{"P1 All Kicks"  , 0, AllThree1+1 , ""},

{"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
{"P2 Start"      , 0, CpsInp018+5, "p2 start"},
{"P2 Up"         , 0, CpsInp000+3, "p2 up"},
{"P2 Down"       , 0, CpsInp000+2, "p2 down"},
{"P2 Left"       , 0, CpsInp000+1, "p2 left"},
{"P2 Right"      , 0, CpsInp000+0, "p2 right"},
{"P2 Low Punch"  , 0, CpsInp000+4, "p2 fire 4"},
{"P2 Mid Punch"  , 0, CpsInp000+5, "p2 fire 5"},
{"P2 High Punch" , 0, CpsInp000+6, "p2 fire 6"},
{"P2 Low Kick"   , 0, CpsInp177+4, "p2 fire 1"},
{"P2 Mid Kick"   , 0, CpsInp177+5, "p2 fire 2"},
{"P2 High Kick"  , 0, CpsInp177+6, "p2 fire 3"},
{"P2 All Punches", 0, AllThree1+2 , ""},
{"P2 All Kicks"  , 0, AllThree1+3 , ""},

{"Diagnostic"    , 0, CpsInp018+6, "diag"},
{"Reset"         , 0, &CpsReset  , "reset"},
{"Service"       , 0, CpsInp018+2, "service"},
};


// Treble Winner - Input for sf2ue
static struct BurnInputInfo Sf2ueInputList[]=
{
{"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
{"P1 Start"      , 0, CpsInp018+4, "p1 start"},
{"P1 Up"         , 0, CpsInp001+3, "p1 up"},
{"P1 Down"       , 0, CpsInp001+2, "p1 down"},
{"P1 Left"       , 0, CpsInp001+1, "p1 left"},
{"P1 Right"      , 0, CpsInp001+0, "p1 right"},
{"P1 Low Punch"  , 0, CpsInp001+4, "p1 fire 4"},
{"P1 Mid Punch"  , 0, CpsInp001+5, "p1 fire 5"},
{"P1 High Punch" , 0, CpsInp001+6, "p1 fire 6"},
{"P1 Low Kick"   , 0, CpsInp1fd+0, "p1 fire 1"},
{"P1 Mid Kick"   , 0, CpsInp1fd+1, "p1 fire 2"},
{"P1 High Kick"  , 0, CpsInp1fd+2, "p1 fire 3"},
{"P1 All Punches", 0, AllThree1+0 , ""},
{"P1 All Kicks"  , 0, AllThree1+4 , ""},

{"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
{"P2 Start"      , 0, CpsInp018+5, "p2 start"},
{"P2 Up"         , 0, CpsInp000+3, "p2 up"},
{"P2 Down"       , 0, CpsInp000+2, "p2 down"},
{"P2 Left"       , 0, CpsInp000+1, "p2 left"},
{"P2 Right"      , 0, CpsInp000+0, "p2 right"},
{"P2 Low Punch"  , 0, CpsInp000+4, "p2 fire 4"},
{"P2 Mid Punch"  , 0, CpsInp000+5, "p2 fire 5"},
{"P2 High Punch" , 0, CpsInp000+6, "p2 fire 6"},
{"P2 Low Kick"   , 0, CpsInp1fd+4, "p2 fire 1"},
{"P2 Mid Kick"   , 0, CpsInp1fd+5, "p2 fire 2"},
{"P2 High Kick"  , 0, CpsInp1fd+6, "p2 fire 3"},
{"P2 All Punches", 0, AllThree1+2 , ""},
{"P2 All Kicks"  , 0, AllThree1+5 , ""},

{"Diagnostic"    , 0, CpsInp018+6, "diag"},
{"Reset"         , 0, &CpsReset  , "reset"},
};

static int Sf2ueInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(Sf2ueInputList) /sizeof(Sf2ueInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=Sf2ueInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;

}
// end of sf2ue input

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n>=0x01 && n<0x1f) return 2;
  if (n>=0x34 && n<0x35) return 2;
  if (n>=0x79 && n<0x84) return 2;
  if (n>=0x8c && n<0x8d) return 2;

  if (n>=0x8f && n<0xad) return 2;
  if (n>=0xc2 && n<0xc3) return 2;
  return 1;
}

static int DrvExit()
{
  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  nPsndIrqPeriod=0; //OLDTST
  BurnScode=NULL;
  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0; Sf2jc=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsAllThree1();
  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

//============================================
//Street Fighter II - The World Warrior Init12
//============================================

static int Drv12Init()
{
  int nRet=0; int i=0;
  Cps=1; Sf2jc=1;
  nCpsRomLen =  0x100000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  for (i=0;i<8;i++)
  {
    int a; a=(i>>1)*0x40000; a+=(i&1); a^=1;
    nRet=BurnLoadRom(CpsRom+a,i,2); if (nRet!=0) return 1;
  }

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  for (i=0;i<3;i++) CpsLoadTiles(CpsGfx+i*0x200000,8+i*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  nCpsLcReg=0x6c; // Layer control register is at 0x6c
  CpsLayEn[1]=0x02;
  CpsLayEn[2]=0x04;
  CpsLayEn[3]=0x08; // Layer enable is different

  // Start of Board ID improvments by KEV. 0x60,0x0402
  CpsBID[0]=0x60;
  CpsBID[1]=0x04;
  CpsBID[2]=0x02;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,20,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,21,1);
  nRet=BurnLoadRom(CpsAd+0x20000,22,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//============================================
//Street Fighter II - The World Warrior Init13
//============================================

static int Drv13Init()
{
  int nRet=0; int i=0;
  Cps=1;
  nCpsRomLen =  0x100000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  for (i=0;i<8;i++)
  {
    int a; a=(i>>1)*0x40000; a+=(i&1); a^=1;
    nRet=BurnLoadRom(CpsRom+a,i,2); if (nRet!=0) return 1;
  }

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  for (i=0;i<3;i++) CpsLoadTiles(CpsGfx+i*0x200000,8+i*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  nCpsLcReg=0x62; // Layer control register is at 0x62
  CpsLayEn[1]=0x20;
  CpsLayEn[2]=0x04;
  CpsLayEn[3]=0x02; // Layer enable is different

  // Start of Board ID improvments by KEV. 0x6e,0x0403
  CpsBID[0]=0x6e;   
  CpsBID[1]=0x04;
  CpsBID[2]=0x03;

  MaskAddr[0]=0x64;
  MaskAddr[1]=0x66;
  MaskAddr[2]=0x68;
  MaskAddr[3]=0x6a;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,20,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,21,1);
  nRet=BurnLoadRom(CpsAd+0x20000,22,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//============================================
//Street Fighter II - The World Warrior Init14
//============================================

static int Drv14Init()
{
  int nRet=0; int i=0;
  Cps=1;
  nCpsRomLen =  0x100000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  for (i=0;i<8;i++)
  {
    int a; a=(i>>1)*0x40000; a+=(i&1); a^=1;
    nRet=BurnLoadRom(CpsRom+a,i,2); if (nRet!=0) return 1;
  }

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  for (i=0;i<3;i++) CpsLoadTiles(CpsGfx+i*0x200000,8+i*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  nCpsLcReg=0x52; // Layer control register is at 0x52
  CpsLayEn[1]=0x08;
  CpsLayEn[2]=0x30;
  CpsLayEn[3]=0x30; // Layer enable is different
 
  // Start of Board ID improvments by KEV. 0x5E,0x0404
  CpsBID[0]=0x5E;   
  CpsBID[1]=0x04;
  CpsBID[2]=0x04;

  MaskAddr[0]=0x54;
  MaskAddr[1]=0x56;
  MaskAddr[2]=0x58;
  MaskAddr[3]=0x5a;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,20,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,21,1);
  nRet=BurnLoadRom(CpsAd+0x20000,22,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//============================================
//Street Fighter II - The World Warrior Init17
//============================================

static int Drv17Init()
{
  int nRet=0; int i=0;
  Cps=1;
  nCpsRomLen =  0x100000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  for (i=0;i<8;i++)
  {
    int a; a=(i>>1)*0x40000; a+=(i&1); a^=1;
    nRet=BurnLoadRom(CpsRom+a,i,2); if (nRet!=0) return 1;
  }

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  for (i=0;i<3;i++) CpsLoadTiles(CpsGfx+i*0x200000,8+i*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  nCpsLcReg=0x54; // Layer control register is at 0x54
  CpsLayEn[1]=0x08;
  CpsLayEn[2]=0x10;
  CpsLayEn[3]=0x02; // Layer enable is different
  
  // Start of Board ID improvments by KEV. 0x48,0x0407
  CpsBID[0]=0x48;   
  CpsBID[1]=0x04;
  CpsBID[2]=0x07;

  MaskAddr[0]=0x52;
  MaskAddr[1]=0x50;
  MaskAddr[2]=0x4e;
  MaskAddr[3]=0x4c;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,20,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,21,1);
  nRet=BurnLoadRom(CpsAd+0x20000,22,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//============================================
//Street Fighter II - The World Warrior Init18
//============================================

static int Drv18Init()
{
  int nRet=0; int i=0;
  Cps=1;
  nCpsRomLen =  0x100000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  for (i=0;i<8;i++)
  {
    int a; a=(i>>1)*0x40000; a+=(i&1); a^=1;
    nRet=BurnLoadRom(CpsRom+a,i,2); if (nRet!=0) return 1;
  }

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  for (i=0;i<3;i++) CpsLoadTiles(CpsGfx+i*0x200000,8+i*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  nCpsLcReg=0xdc; // Layer control register is at 0xdc
  CpsLayEn[1]=0x10;
  CpsLayEn[2]=0x0a;
  CpsLayEn[3]=0x0a; // Layer enable is different

  // Start of Board ID improvments by KEV. 0xd0,0x0408
  CpsBID[0]=0xd0;   
  CpsBID[1]=0x04;
  CpsBID[2]=0x08;

  MaskAddr[0]=0xda;
  MaskAddr[1]=0xd8;
  MaskAddr[2]=0xd6;
  MaskAddr[3]=0xd4;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,20,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,21,1);
  nRet=BurnLoadRom(CpsAd+0x20000,22,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//=============================================
//Street Fighter II - The World Warrior (World)
//=============================================

static int Sf2ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2RomDesc[]=
{
// 0
  {"sf2_30a.bin",0x20000,0x57bd7051, 0x10}, //  0 68000 code
  {"sf2e_37b.rom",0x20000,0x62691cdd, 0x10},
  {"sf2_31a.bin",0x20000,0xa673143d, 0x10},
  {"sf2_38a.bin",0x20000,0x4c2ccef7, 0x10},
  {"sf2_28a.bin" ,0x20000,0x4009955e, 0x10},
  {"sf2_35a.bin" ,0x20000,0x8c1f3994, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2) STD_ROM_FN(Sf2)

struct BurnDriver BurnDrvCpsSf2=
{
  {"sf2","Street Fighter 2 (World)","","Capcom","CPS1","1991",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2ZipName,Sf2RomInfo,Sf2RomName,DrvInputInfo,
  Drv17Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//==================================================
//Street Fighter II - The World Warrior (USA Rev. A)
//==================================================

static int Sf2uaZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2ua.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2uaRomDesc[]=
{
// 0
  {"sf2u.30a",0x20000,0x08beb861, 0x10}, //  0 68000 code
  {"sf2u.37a",0x20000,0xb7638d69, 0x10},
  {"sf2u.31a",0x20000,0x0d5394e0, 0x10},
  {"sf2u.38a",0x20000,0x42d6a79e, 0x10},
  {"sf2u.28a" ,0x20000,0x387a175c, 0x10},
  {"sf2u.35a" ,0x20000,0xa1a5adcc, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ua) STD_ROM_FN(Sf2ua)

struct BurnDriver BurnDrvCpsSf2ua=
{
  {"sf2ua","Street Fighter 2 (USA rev A)","","Capcom","CPS1","1991","sf2"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2uaZipName,Sf2uaRomInfo,Sf2uaRomName,DrvInputInfo,
  Drv17Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//==================================================
//Street Fighter II - The World Warrior (USA Rev. B)
//==================================================

static int Sf2ubZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2ub.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2ubRomDesc[]=
{
// 0
  {"sf2_30a.bin",0x20000,0x57bd7051, 0x10}, //  0 68000 code
  {"sf2u.37b",0x20000,0x4a54d479, 0x10},
  {"sf2_31a.bin",0x20000,0xa673143d, 0x10},
  {"sf2_38a.bin",0x20000,0x4c2ccef7, 0x10},
  {"sf2_28a.bin" ,0x20000,0x4009955e, 0x10},
  {"sf2_35a.bin" ,0x20000,0x8c1f3994, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ub) STD_ROM_FN(Sf2ub)

struct BurnDriver BurnDrvCpsSf2ub=
{
  {"sf2ub","Street Fighter 2 (USA rev B)","","Capcom","CPS1","1991","sf2"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2ubZipName,Sf2ubRomInfo,Sf2ubRomName,DrvInputInfo,
  Drv17Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//==================================================
//Street Fighter II - The World Warrior (USA Rev. E)
//==================================================

static int Sf2ueZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2ue.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2ueRomDesc[]=
{
// 0
  {"sf2u.30e",0x20000,0xf37cd088, 0x10}, //  0 68000 code
  {"sf2u.37e",0x20000,0x6c61a513, 0x10},
  {"sf2u.31e",0x20000,0x7c4771b4, 0x10},
  {"sf2u.38e",0x20000,0xa4bd0cd9, 0x10},
  {"sf2u.28e",0x20000,0xe3b95625, 0x10},
  {"sf2u.35e",0x20000,0x3648769a, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ue) STD_ROM_FN(Sf2ue)

struct BurnDriver BurnDrvCpsSf2ue=
{
  {"sf2ue","Street Fighter 2 (USA rev E)","","Capcom","CPS1","1991","sf2"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2ueZipName,Sf2ueRomInfo,Sf2ueRomName,Sf2ueInputInfo,
  Drv18Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//==================================================
//Street Fighter II - The World Warrior (USA Rev. I)
//==================================================

static int Sf2uiZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2ui.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2uiRomDesc[]=
{
// 0
  {"sf2u.30i",0x20000,0xfe39ee33, 0x10}, //  0 68000 code
  {"sf2u.37i",0x20000,0x9df707dd, 0x10},
  {"sf2u.31i",0x20000,0x69a0a301, 0x10},
  {"sf2u.38i",0x20000,0x4cb46daf, 0x10},
  {"sf2u.28i" ,0x20000,0x1580be4c, 0x10},
  {"sf2u.35i" ,0x20000,0x1468d185, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ui) STD_ROM_FN(Sf2ui)

struct BurnDriver BurnDrvCpsSf2ui=
{
  {"sf2ui","Street Fighter 2 (USA rev I)","","Capcom","CPS1","1991","sf2"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2uiZipName,Sf2uiRomInfo,Sf2uiRomName,DrvInputInfo,
  Drv14Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//=============================================
//Street Fighter II - The World Warrior (Japan)
//=============================================

static int Sf2jZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2j.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2jRomDesc[]=
{
// 0
  {"sf2j30.bin",0x20000,0x79022b31, 0x10}, //  0 68000 code
  {"sf2j37.bin",0x20000,0x516776ec, 0x10},
  {"sf2j31.bin",0x20000,0xfe15cb39, 0x10},
  {"sf2j38.bin",0x20000,0x38614d70, 0x10},
  {"sf2j28.bin" ,0x20000,0xd283187a, 0x10},
  {"sf2j35.bin" ,0x20000,0xd28158e4, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2j) STD_ROM_FN(Sf2j)

struct BurnDriver BurnDrvCpsSf2j=
{
  {"sf2j","Street Fighter 2 (Japan)","","Capcom","CPS1","1991","sf2"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2jZipName,Sf2jRomInfo,Sf2jRomName,DrvInputInfo,
  Drv13Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//====================================================
//Street Fighter II - The World Warrior (Japan Rev. A)
//====================================================

static int Sf2jaZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2ja.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2jaRomDesc[]=
{
// 0
  {"sf2_30a.bin",0x20000,0x57bd7051, 0x10}, //  0 68000 code
  {"sf2j_37a.bin",0x20000,0x1e1f6844, 0x10},
  {"sf2_31a.bin",0x20000,0xa673143d, 0x10},
  {"sf2_38a.bin",0x20000,0x4c2ccef7, 0x10},
  {"sf2_28a.bin" ,0x20000,0x4009955e, 0x10},
  {"sf2_35a.bin" ,0x20000,0x8c1f3994, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ja) STD_ROM_FN(Sf2ja)

struct BurnDriver BurnDrvCpsSf2ja=
{
  {"sf2ja","Street Fighter 2 (Japan rev A)","","Capcom","CPS1","1991","sf2"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2jaZipName,Sf2jaRomInfo,Sf2jaRomName,DrvInputInfo,
  Drv17Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//====================================================
//Street Fighter II - The World Warrior (Japan Rev. C)
//====================================================

static int Sf2jcZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2jc.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2jcRomDesc[]=
{
// 0
  {"sf2_30c.bin",0x20000,0x8add35ec, 0x10}, //  0 68000 code
  {"sf2j_37c.bin",0x20000,0x0d74a256, 0x10},
  {"sf2_31c.bin",0x20000,0xc4fff4a9, 0x10},
  {"sf2_38c.bin",0x20000,0x8210fc0e, 0x10},
  {"sf2_28c.bin" ,0x20000,0x6eddd5e8, 0x10},
  {"sf2_35c.bin" ,0x20000,0x6bcb404c, 0x10},
  {"sf2_29a.bin" ,0x20000,0xbb4af315, 0x10},
  {"sf2_36a.bin" ,0x20000,0xc02a13eb, 0x10},

// 8
  {"sf2_06.bin",0x80000,0x22c9cc8e,    1},
  {"sf2_08.bin",0x80000,0x57213be8,    1},
  {"sf2_05.bin",0x80000,0xba529b4f,    1},
  {"sf2_07.bin",0x80000,0x4b1b33a8,    1},
  {"sf2_15.bin",0x80000,0x2c7e2229,    1},
  {"sf2_17.bin",0x80000,0xb5548f17,    1},
  {"sf2_14.bin",0x80000,0x14b84312,    1},
  {"sf2_16.bin",0x80000,0x5e9cd89a,    1},
  {"sf2_25.bin",0x80000,0x994bfa58,    1},
  {"sf2_27.bin",0x80000,0x3e66ad9d,    1},
  {"sf2_24.bin",0x80000,0xc1befaa8,    1},
  {"sf2_26.bin",0x80000,0x0627c831,    1},

// 20
// z80 program
  {"sf2_09.bin"  ,0x10000,0xa4823a1b,    2},
// adpcm samples
  {"sf2_18.bin"  ,0x20000,0x7f162009,    2},
  {"sf2_19.bin"  ,0x20000,0xbeade53f,    2},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2jc) STD_ROM_FN(Sf2jc)

struct BurnDriver BurnDrvCpsSf2jc=
{
  {"sf2jc","Street Fighter 2 (Japan rev C)","","Capcom","CPS1","1991","sf2"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2jcZipName,Sf2jcRomInfo,Sf2jcRomName,DrvInputInfo,
  Drv12Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
