#include "cps.h"
// Street Fighter II' CE/Turbo - All-in-One Driver 2.12 by Mike_Haggar_99@hotmail.com
// Street Fighter II' - CE (Rainbow Set 1) - Driver by KEV
// Street Fighter II' - CE (Rainbow Set 2) - Driver by JeldrosJ3
// Load menu display adjustment by LoopMaster
// Cheat engine source by HyperYagami


static unsigned char nCpuSpeed=7;

static unsigned char AllThree1[4]={0,0,0,0};

static int CpsFsAllThree1()
{
 // Process all three punches and kicks
 if (AllThree1[0]) { CpsFsi[ 6].pVal[0]=1; CpsFsi[ 7].pVal[0]=1; CpsFsi[ 8].pVal[0]=1; }
 if (AllThree1[1]) { CpsFsi[ 9].pVal[0]=1; CpsFsi[10].pVal[0]=1; CpsFsi[11].pVal[0]=1; }
 if (AllThree1[2]) { CpsFsi[20].pVal[0]=1; CpsFsi[21].pVal[0]=1; CpsFsi[22].pVal[0]=1; }
 if (AllThree1[3]) { CpsFsi[23].pVal[0]=1; CpsFsi[24].pVal[0]=1; CpsFsi[25].pVal[0]=1; }
 return 0;
}
static struct BurnInputInfo DrvInputList[]=
{
{"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
{"P1 Start"      , 0, CpsInp018+4, "p1 start"},
{"P1 Up"         , 0, CpsInp001+3, "p1 up"},
{"P1 Down"       , 0, CpsInp001+2, "p1 down"},
{"P1 Left"       , 0, CpsInp001+1, "p1 left"},
{"P1 Right"      , 0, CpsInp001+0, "p1 right"},
{"P1 Low Punch"  , 0, CpsInp001+4, "p1 fire 4"},
{"P1 Mid Punch"  , 0, CpsInp001+5, "p1 fire 5"},
{"P1 High Punch" , 0, CpsInp001+6, "p1 fire 6"},
{"P1 Low Kick"   , 0, CpsInp177+0, "p1 fire 1"},
{"P1 Mid Kick"   , 0, CpsInp177+1, "p1 fire 2"},
{"P1 High Kick"  , 0, CpsInp177+2, "p1 fire 3"},
{"P1 All Punches", 0, AllThree1+0 , ""},
{"P1 All Kicks"  , 0, AllThree1+1 , ""},

{"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
{"P2 Start"      , 0, CpsInp018+5, "p2 start"},
{"P2 Up"         , 0, CpsInp000+3, "p2 up"},
{"P2 Down"       , 0, CpsInp000+2, "p2 down"},
{"P2 Left"       , 0, CpsInp000+1, "p2 left"},
{"P2 Right"      , 0, CpsInp000+0, "p2 right"},
{"P2 Low Punch"  , 0, CpsInp000+4, "p2 fire 4"},
{"P2 Mid Punch"  , 0, CpsInp000+5, "p2 fire 5"},
{"P2 High Punch" , 0, CpsInp000+6, "p2 fire 6"},
{"P2 Low Kick"   , 0, CpsInp177+4, "p2 fire 1"},
{"P2 Mid Kick"   , 0, CpsInp177+5, "p2 fire 2"},
{"P2 High Kick"  , 0, CpsInp177+6, "p2 fire 3"},
{"P2 All Punches", 0, AllThree1+2 , ""},
{"P2 All Kicks"  , 0, AllThree1+3 , ""},

{"Diagnostic"    , 0, CpsInp018+6, "diag"},
{"Reset"         , 0, &CpsReset  , "reset"},
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  n&=0x1ff;
  if (n<=0x3f) return 2; // music
  if (n>=0xd1 && n<=0xd6) return 2; // music
  return 1; // sound effect
}

static int DrvExit()
{
  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST
  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  int nSpeed=0;

  CpsFsAllThree1();
  CpsFsStopOpposite(); // stop opposite directions

  nSpeed=nCpuSpeed; if (nSpeed>32) nSpeed=32;
  nCpsCycles=nSpeed*1000000/60;
  // Carry on to CPS frame
  Cps1Frame();
  nCpsCycles=0;
  return 0;
}

//==========================================
//Street Fighter II' C.E./Turbo Regular Init
//==========================================

static int DrvInit()
{
  int nRet=0; int i=0;
  Cps=1;
  nCpsRomLen =3*0x080000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms (they are already byteswapped)
  for (i=0;i<3;i++)
  { nRet=BurnLoadRom(CpsRom+0x080000*i,0+i,1); if (nRet!=0) return 1; }

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  CpsLoadTiles(CpsGfx+0x000000,3+0*4);
  CpsLoadTiles(CpsGfx+0x200000,3+1*4);
  CpsLoadTiles(CpsGfx+0x400000,3+2*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  MaskAddr[0]=0x68;
  MaskAddr[1]=0x6a;
  MaskAddr[2]=0x6c;
  MaskAddr[3]=0x6e;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,15,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,16,1);
  nRet=BurnLoadRom(CpsAd+0x20000,17,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Start of Board ID improvments by KEV. 0x48,0x0407
  CpsBID[0]=0x48;
  CpsBID[1]=0x04;
  CpsBID[2]=0x07;

  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();
  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//==============================================================
//Street Fighter II' - Champion Edition (Accelerator Pt.II) Init
//==============================================================

static int Sf2accp2Init()
{
   int nRet=0; int i=0;
   Cps=1;
   nCpsRomLen =3*0x080000;
   nCpsGfxLen =3*0x200000;
   nCpsZRomLen=  0x010000;
   nCpsAdLen  =2*0x020000;
   nRet=CpsInit(); if (nRet!=0) return 1;

   // Load program roms (they are already byteswapped)
   for (i=0;i<3;i++)
   { nRet=BurnLoadRom(CpsRom+0x080000*i,0+i,1); if (nRet!=0) return 1; }


   // Stuff to patch out the "odd branch" for sf2accp2 starts here
   CpsRom[0x11755]=0x4e;
   CpsRom[0x11756]=0x71;
   // Ends here

   // Load up and interleve each set of 4 roms to make the 16x16 tiles
   CpsLoadTiles(CpsGfx+0x000000,3+0*4);
   CpsLoadTiles(CpsGfx+0x200000,3+1*4);
   CpsLoadTiles(CpsGfx+0x400000,3+2*4);

   nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

   MaskAddr[0]=0x68;
   MaskAddr[1]=0x6a;
   MaskAddr[2]=0x6c;
   MaskAddr[3]=0x6e;

   // Load Z80 Rom
   nRet=BurnLoadRom(CpsZRom,15,1);
   BurnScode=DrvScode;

   // Load ADPCM data
   nRet=BurnLoadRom(CpsAd        ,16,1);
   nRet=BurnLoadRom(CpsAd+0x20000,17,1);

   // Set dip switches
   SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
   // Start of Board ID improvments by KEV. 0x48,0x0407
   CpsBID[0]=0x48;   
   CpsBID[1]=0x04;
   CpsBID[2]=0x07;
   //end
   nPsndIrqPeriod=(60<<10)/250; //OLDTST

   ConstructCheatList();
   ConstructDIPSWList();

   nRet=CpsRunInit();

   if (nRet!=0) return 1;
   // Ready to go
   return 0;
}

//==========================================================
//Street Fighter II' - Champion Edition (Rainbow Set 1) Init
//==========================================================

static int Sf2rbInit()
{
  int nRet=0; int i=0;
  Cps=1;
  nCpsRomLen =3*0x080000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms (they are already byteswapped)
  for (i=0;i<3;i++)
  { nRet=BurnLoadRom(CpsRom+0x080000*i,0+i,1); if (nRet!=0) return 1; }


  // Stuff to patch the copy protection for sf2rb starts here
  BurnByteswap(CpsRom,0x080000*2);  // must byteswap the 2 new code roms
  CpsRom[0xe5465]=0x60;
  CpsRom[0xe5464]=0x12;
  // Ends here

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  CpsLoadTiles(CpsGfx+0x000000,3+0*4);
  CpsLoadTiles(CpsGfx+0x200000,3+1*4);
  CpsLoadTiles(CpsGfx+0x400000,3+2*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  MaskAddr[0]=0x68;
  MaskAddr[1]=0x6a;
  MaskAddr[2]=0x6c;
  MaskAddr[3]=0x6e;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,15,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,16,1);
  nRet=BurnLoadRom(CpsAd+0x20000,17,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Start of Board ID improvments by KEV. 0x48,0x0407
  CpsBID[0]=0x48;   
  CpsBID[1]=0x04;
  CpsBID[2]=0x07;
  //end
  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//==========================================================
//Street Fighter II' - Champion Edition (Rainbow Set 2) Init
//==========================================================

static int Sf2rb2Init()
{
  int nRet=0; int i=0;
  Cps=1;
  nCpsRomLen =8*0x20000+0x80000;
  nCpsGfxLen =3*0x200000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000000,0,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x000001,1,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x040000,2,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x040001,3,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x080000,4,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x080001,5,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x0c0000,6,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x0c0001,7,2); if (nRet!=0) return 1;//ROM_LOAD16_BYTE
  nRet=BurnLoadRom(CpsRom+0x100000,8,1); if (nRet!=0) return 1;//ROM_LOAD16_WORD_SWAP

  // Stuff to patch the copy protection for sf2rb2 starts here
  BurnByteswap(CpsRom,0x080000*2);  // must byteswap the 2 new code roms
  CpsRom[0xe5333]=0x60;
  CpsRom[0xe5332]=0x14;
  // Ends here

  // Load up and interleve each set of 4 roms to make the 16x16 tiles
  for (i=0;i<3;i++) CpsLoadTiles(CpsGfx+i*0x200000,9+i*4);

  nCpsGfxScroll[1]=nCpsGfxScroll[2]=nCpsGfxScroll[3]=0x400000; // Offset to Scroll tiles

  MaskAddr[0]=0x68;
  MaskAddr[1]=0x6a;
  MaskAddr[2]=0x6c;
  MaskAddr[3]=0x6e;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,21,1);
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,22,1);
  nRet=BurnLoadRom(CpsAd+0x20000,23,1);

  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Start of Board ID improvments by KEV. 0x48,0x0407
  CpsBID[0]=0x48;   
  CpsBID[1]=0x04;
  CpsBID[2]=0x07;
  //end
  nPsndIrqPeriod=(60<<10)/250; //OLDTST

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit();

  if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

//=============================================
//Street Fighter II' - Champion Edition (World)
//=============================================

static int Sf2ceZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2ceRomDesc[]=
{
  {"sf2ce.23" ,0x80000,0x3f846b74, 0x10}, //  0 68000 code
  {"sf2ce.22" ,0x80000,0x99f1cca4, 0x10}, //  1
  {"s92_21a.bin" ,0x80000,0x925a7877, 0x10}, //  2

// 3
  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

// 11
  {"s92_10.bin"   ,0x80000,0x960687d5,    1},
  {"s92_11.bin"   ,0x80000,0x978ecd18,    1},
  {"s92_12.bin"   ,0x80000,0xd6ec9a0a,    1},
  {"s92_13.bin"   ,0x80000,0xed2c67f6,    1},

// 15
// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ce) STD_ROM_FN(Sf2ce)

struct BurnDriver BurnDrvCpsSf2ce=
{
  {"sf2ce","Street Fighter 2 - C.E. (World)","","Capcom","CPS1","1992",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2ceZipName,Sf2ceRomInfo,Sf2ceRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//=============================================
//Street Fighter II' - Champion Edition (Japan)
//=============================================

static int Sf2cejZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2cej.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2cejRomDesc[]=
{
  {"s92j_23b.bin" ,0x80000,0x140876c5, 0x10}, //  0 68000 code
  {"s92j_22b.bin" ,0x80000,0x2fbb3bfe, 0x10}, //  1
  {"s92_21a.bin" ,0x80000,0x925a7877, 0x10}, //  2

// 3
  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

// 11
  {"s92_10.bin"   ,0x80000,0x960687d5,    1},
  {"s92_11.bin"   ,0x80000,0x978ecd18,    1},
  {"s92_12.bin"   ,0x80000,0xd6ec9a0a,    1},
  {"s92_13.bin"   ,0x80000,0xed2c67f6,    1},

// 15
// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2cej) STD_ROM_FN(Sf2cej)

struct BurnDriver BurnDrvCpsSf2cej=
{
  {"sf2cej","Street Fighter 2 - C.E. (Japan)","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2cejZipName,Sf2cejRomInfo,Sf2cejRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//==================================================
//Street Fighter II' - Champion Edition (USA Rev. A)
//==================================================

static int Sf2ceuaZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2ceua.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2ceuaRomDesc[]=
{
  {"s92u-23a" ,0x80000,0xac44415b, 0x10}, //  0 68000 code
  {"sf2ce.22" ,0x80000,0x99f1cca4, 0x10}, //  1
  {"s92_21a.bin" ,0x80000,0x925a7877, 0x10}, //  2

// 3
  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

// 11
  {"s92_10.bin"   ,0x80000,0x960687d5,    1},
  {"s92_11.bin"   ,0x80000,0x978ecd18,    1},
  {"s92_12.bin"   ,0x80000,0xd6ec9a0a,    1},
  {"s92_13.bin"   ,0x80000,0xed2c67f6,    1},

// 15
// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ceua) STD_ROM_FN(Sf2ceua)

struct BurnDriver BurnDrvCpsSf2ceua=
{
  {"sf2ceua","Street Fighter 2 - C.E. (USA rev A)","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2ceuaZipName,Sf2ceuaRomInfo,Sf2ceuaRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//==================================================
//Street Fighter II' - Champion Edition (USA Rev. B)
//==================================================

static int Sf2ceubZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2ceub.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2ceubRomDesc[]=
{
  {"s92-23b" ,0x80000,0x996a3015, 0x10}, //  0 68000 code
  {"s92-22b" ,0x80000,0x2bbe15ed, 0x10}, //  1
  {"s92-21b" ,0x80000,0xb383cb1c, 0x10}, //  2

// 3
  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

// 11
  {"s92_10.bin"   ,0x80000,0x960687d5,    1},
  {"s92_11.bin"   ,0x80000,0x978ecd18,    1},
  {"s92_12.bin"   ,0x80000,0xd6ec9a0a,    1},
  {"s92_13.bin"   ,0x80000,0xed2c67f6,    1},

// 15
// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2ceub) STD_ROM_FN(Sf2ceub)

struct BurnDriver BurnDrvCpsSf2ceub=
{
  {"sf2ceub","Street Fighter 2 - C.E. (USA rev B)","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2ceubZipName,Sf2ceubRomInfo,Sf2ceubRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//=========================================================
//Street Fighter II' - Champion Edition (Accelerator Pt.II)
//=========================================================

static int Sf2accp2ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2accp2.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2accp2RomDesc[]=
{
  {"sf2ca-23.bin" ,0x80000,0x36c3ba2f, 0x10}, //  0 68000 code
  {"sf2ca-22.bin" ,0x80000,0x0550453d, 0x10}, //  1
  {"sf2ca-21.bin" ,0x40000,0x4c1c43ba, 0x10}, //  2

// 3
  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

// 11
  {"s92_10.bin"   ,0x80000,0x960687d5,    1},
  {"s92_11.bin"   ,0x80000,0x978ecd18,    1},
  {"s92_12.bin"   ,0x80000,0xd6ec9a0a,    1},
  {"s92_13.bin"   ,0x80000,0xed2c67f6,    1},

// 15
// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2accp2) STD_ROM_FN(Sf2accp2)

struct BurnDriver BurnDrvCpsSf2accp2=
{
  {"sf2accp2","Street Fighter 2 - C.E. Accelerator Pt.II","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2accp2ZipName,Sf2accp2RomInfo,Sf2accp2RomName,DrvInputInfo,
  Sf2accp2Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//=====================================================
//Street Fighter II' - Champion Edition (Rainbow Set 1)
//=====================================================

static int Sf2rbZipName(char **pszName,unsigned int i)
{
if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
if (i==1) { if (pszName!=NULL) *pszName="sf2rb.zip"; return 0; }
return 1;
}


static struct StdRomInfo Sf2rbRomDesc[]=
{
{"sf2d__23.rom" ,0x80000,0x450532b0, 0x10}, 
{"sf2d__22.rom" ,0x80000,0xfe9d9cf5, 0x10}, 
{"s92_21a.bin" ,0x80000,0x925a7877, 0x10},

// 3
{"s92_01.bin" ,0x80000,0x03b0d852, 1},
{"s92_02.bin" ,0x80000,0x840289ec, 1},
{"s92_03.bin" ,0x80000,0xcdb5f027, 1},
{"s92_04.bin" ,0x80000,0xe2799472, 1},

{"s92_05.bin" ,0x80000,0xba8a2761, 1},
{"s92_06.bin" ,0x80000,0xe584bfb5, 1},
{"s92_07.bin" ,0x80000,0x21e3f87d, 1},
{"s92_08.bin" ,0x80000,0xbefc47df, 1},

// 11
{"s92_10.bin" ,0x80000,0x960687d5, 1},
{"s92_11.bin" ,0x80000,0x978ecd18, 1},
{"s92_12.bin" ,0x80000,0xd6ec9a0a, 1},
{"s92_13.bin" ,0x80000,0xed2c67f6, 1},

// 15
// z80 program
{"s92_09.bin" ,0x10000,0x08f6b60e, 2},
// adpcm samples
{"s92_18.bin" ,0x20000,0x7f162009, 2},
{"s92_19.bin" ,0x20000,0xbeade53f, 2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2rb) STD_ROM_FN(Sf2rb)

struct BurnDriver BurnDrvCpsSf2rb=
{
{"sf2rb","Street Fighter 2 - C.E. Rainbow Edition (Set 1)","","Capcom","CPS1","1992","sf2ce"},
1,2,HARDWARE_CAPCOM_CPS1,
Sf2rbZipName,Sf2rbRomInfo,Sf2rbRomName,DrvInputInfo,
Sf2rbInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
&CpsRecalcPal,384,224,4,3
};

//=====================================================
//Street Fighter II' - Champion Edition (Rainbow Set 2)
//=====================================================

static int Sf2rb2ZipName(char **pszName,unsigned int i)
{
if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
if (i==1) { if (pszName!=NULL) *pszName="sf2rb2.zip"; return 0; }
return 1;
}

static struct StdRomInfo Sf2rb2RomDesc[]=
{
{"27.bin" ,0x20000,0x40296ecd, 0x10}, 
{"31.bin" ,0x20000,0x87954a41, 0x10},
{"26.bin" ,0x20000,0xa6974195, 0x10}, 
{"30.bin" ,0x20000,0x8141fe32, 0x10},
{"25.bin" ,0x20000,0x9ef8f772, 0x10}, 
{"29.bin" ,0x20000,0x7d9c479c, 0x10},
{"24.bin" ,0x20000,0x93579684, 0x10}, 
{"28.bin" ,0x20000,0xff728865, 0x10},
{"s92_21a.bin" ,0x80000,0x925a7877, 0x10},

// 9
{"s92_01.bin" ,0x80000,0x03b0d852, 1},
{"s92_02.bin" ,0x80000,0x840289ec, 1},
{"s92_03.bin" ,0x80000,0xcdb5f027, 1},
{"s92_04.bin" ,0x80000,0xe2799472, 1},
// 13
{"s92_05.bin" ,0x80000,0xba8a2761, 1},
{"s92_06.bin" ,0x80000,0xe584bfb5, 1},
{"s92_07.bin" ,0x80000,0x21e3f87d, 1},
{"s92_08.bin" ,0x80000,0xbefc47df, 1},
// 17
{"s92_10.bin" ,0x80000,0x960687d5, 1},
{"s92_11.bin" ,0x80000,0x978ecd18, 1},
{"s92_12.bin" ,0x80000,0xd6ec9a0a, 1},
{"s92_13.bin" ,0x80000,0xed2c67f6, 1},

// 21
// z80 program
{"s92_09.bin" ,0x10000,0x08f6b60e, 2},
// adpcm samples
{"s92_18.bin" ,0x20000,0x7f162009, 2},
{"s92_19.bin" ,0x20000,0xbeade53f, 2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2rb2) STD_ROM_FN(Sf2rb2)

struct BurnDriver BurnDrvCpsSf2rb2=
{
{"sf2rb2","Street Fighter 2 - C.E. Rainbow Edition (Set 2)","","Capcom","CPS1","1992","sf2ce"},
1,2,HARDWARE_CAPCOM_CPS1,
Sf2rb2ZipName,Sf2rb2RomInfo,Sf2rb2RomName,DrvInputInfo,
Sf2rb2Init,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
&CpsRecalcPal,384,224,4,3
};

//================================================
//Street Fighter II' - Champion Edition (Red Wave)
//================================================

static int Sf2redZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2red.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2redRomDesc[]=
{
  {"sf2red.23" ,0x80000,0x40276abb, 0x10}, //  0 68000 code
  {"sf2red.22" ,0x80000,0x18daf387, 0x10}, //  1
  {"sf2red.21" ,0x80000,0x52c486bb, 0x10}, //  2

// 3
  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

// 11
  {"s92_10.bin"   ,0x80000,0x960687d5,    1},
  {"s92_11.bin"   ,0x80000,0x978ecd18,    1},
  {"s92_12.bin"   ,0x80000,0xd6ec9a0a,    1},
  {"s92_13.bin"   ,0x80000,0xed2c67f6,    1},

// 15
// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2red) STD_ROM_FN(Sf2red)

struct BurnDriver BurnDrvCpsSf2red=
{
  {"sf2red","Street Fighter 2 - C.E. Red Wave","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2redZipName,Sf2redRomInfo,Sf2redRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//============================================
//Street Fighter II' - Champion Edition (V004)
//============================================

static int Sf2v004ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2v004.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2v004RomDesc[]=
{
  {"sf2v004.23" ,0x80000,0x52d19f2c, 0x10}, //  0 68000 code
  {"sf2v004.22" ,0x80000,0x4b26fde7, 0x10}, //  1
  {"sf2red.21" ,0x80000,0x52c486bb, 0x10}, //  2

// 3
  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

// 11
  {"s92_10.bin"   ,0x80000,0x960687d5,    1},
  {"s92_11.bin"   ,0x80000,0x978ecd18,    1},
  {"s92_12.bin"   ,0x80000,0xd6ec9a0a,    1},
  {"s92_13.bin"   ,0x80000,0xed2c67f6,    1},

// 15
// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
// 18
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Sf2v004) STD_ROM_FN(Sf2v004)

struct BurnDriver BurnDrvCpsSf2v004=
{
  {"sf2v004","Street Fighter 2 - C.E. V004","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2v004ZipName,Sf2v004RomInfo,Sf2v004RomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//=========================================
//Street Fighter II' - Hyper Fighting (USA)
//=========================================

static int Sf2tZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2t.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2tRomDesc[]=
{
  {"sf2.23"   ,0x80000,0x89a1fc38, 0x10}, //  0 68000 code
  {"sf2_22.bin"   ,0x80000,0xaea6e035, 0x10}, //  1
  {"sf2_21.bin"   ,0x80000,0xfd200288, 0x10}, //  2

  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

  {"s2t_10.bin"  ,0x80000,0x3c042686,    1},
  {"s2t_11.bin"  ,0x80000,0x8b7e7183,    1},
  {"s2t_12.bin"  ,0x80000,0x293c888c,    1},
  {"s2t_13.bin"  ,0x80000,0x842b35a4,    1},

// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
};

STD_ROM_PICK(Sf2t) STD_ROM_FN(Sf2t)

struct BurnDriver BurnDrvCpsSf2t=
{
  {"sf2t","Street Fighter 2 - Hyper Fighting (USA)","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2tZipName,Sf2tRomInfo,Sf2tRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//=================================================
//Street Fighter II' Turbo - Hyper Fighting (Japan)
//=================================================

static int Sf2tjZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sf2ce.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sf2tj.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sf2tjRomDesc[]=
{
  {"s2tj_23.bin"   ,0x80000,0xea73b4dc, 0x10}, //  0 68000 code
  {"s2t_22.bin"   ,0x80000,0xaea6e035, 0x10}, //  1
  {"s2t_21.bin"   ,0x80000,0xfd200288, 0x10}, //  2

  {"s92_01.bin"   ,0x80000,0x03b0d852,    1},
  {"s92_02.bin"   ,0x80000,0x840289ec,    1},
  {"s92_03.bin"   ,0x80000,0xcdb5f027,    1},
  {"s92_04.bin"   ,0x80000,0xe2799472,    1},

  {"s92_05.bin"   ,0x80000,0xba8a2761,    1},
  {"s92_06.bin"   ,0x80000,0xe584bfb5,    1},
  {"s92_07.bin"   ,0x80000,0x21e3f87d,    1},
  {"s92_08.bin"   ,0x80000,0xbefc47df,    1},

  {"s2t_10.bin"  ,0x80000,0x3c042686,    1},
  {"s2t_11.bin"  ,0x80000,0x8b7e7183,    1},
  {"s2t_12.bin"  ,0x80000,0x293c888c,    1},
  {"s2t_13.bin"  ,0x80000,0x842b35a4,    1},

// z80 program
  {"s92_09.bin"   ,0x10000,0x08f6b60e,    2},
// adpcm samples
  {"s92_18.bin"   ,0x20000,0x7f162009,    2},
  {"s92_19.bin"   ,0x20000,0xbeade53f,    2},
};

STD_ROM_PICK(Sf2tj) STD_ROM_FN(Sf2tj)

struct BurnDriver BurnDrvCpsSf2tj=
{
  {"sf2tj","Street Fighter 2 Turbo - Hyper Fighting (Japan)","","Capcom","CPS1","1992","sf2ce"},
  1,2,HARDWARE_CAPCOM_CPS1,
  Sf2tjZipName,Sf2tjRomInfo,Sf2tjRomName,DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};
