// Audio Output
#include "app.h"
#define wav_log_test

static unsigned int nAudSelect=0;	// Which video output is selected

extern struct AudOut
	AudOutDx
	;

static struct AudOut *pAudOut[]=
{
	&AudOutDx,
};

#define AUD_LEN (sizeof(pAudOut)/sizeof(pAudOut[0]))

int AudBlankSound()
{
	if (nAudSelect>=AUD_LEN) return 1;
	return pAudOut[nAudSelect]->BlankSound();
}

// This function checks the DSound loop, and if necessary gets some more sound
// and a picture.
int AudSoundCheck()
{
	if (nAudSelect>=AUD_LEN) return 1;
	return pAudOut[nAudSelect]->SoundCheck();
}

int AudSoundInit(HWND hWnd)
{
	if (nAudSelect>=AUD_LEN) return 1;
	return pAudOut[nAudSelect]->SoundInit(hWnd);
}

int AudSoundPlay()
{
	if (nAudSelect>=AUD_LEN) return 1;
	return pAudOut[nAudSelect]->SoundPlay();
}

int AudSoundStop()
{
	if (nAudSelect>=AUD_LEN) return 1;
	return pAudOut[nAudSelect]->SoundStop();
}

int AudSoundExit()
{
	if (nAudSelect>=AUD_LEN) return 1;
	return pAudOut[nAudSelect]->SoundExit();
}

int AudSoundSetVolume()
{
	if (nAudSelect>=AUD_LEN) return 1;
	return pAudOut[nAudSelect]->SoundSetVolume();
}
