// Burner Input Constant dialog module EXTENDED, Type 1
// By HyperYagami, based on the original code (inpc.cpp) by dayvee
#include "app.h"
#include "cheat.h"

HWND hInpcX1Dlg=NULL; // Handle to the Input Dialog
unsigned int nInpcX1Input=0; // The input number we are redefining
static struct CheatInfo *pTempCheatInfo;

static HWND hValue=NULL; // Handle to value edit control
static struct GameInp *pgi=NULL; // Current GameInp

static int InpcX1Init()
{
	char szText[128]; int nCurrent=0;
	unsigned int i, a=0;

	struct BurnInputInfo bii; // Info about the input

	hValue=GetDlgItem(hInpcX1Dlg,IDC_INPCX1_VALUE); // Get Edit controls

	// Get the extra info about the input
	memset(&bii,0,sizeof(bii));
	BurnDrvGetInputInfo(&bii,nInpcX1Input);
	if (bii.szName==NULL) bii.szName="";

	// Set the dialog title
	sprintf(szText,"Edit %.100s",bii.szName);
	SetWindowText(hInpcX1Dlg,szText);

	pgi=NULL;
	if (nInpcX1Input>=nGameInpCount) return 1; // input out of range
	pgi=GameInp+nInpcX1Input;

	// Get current constant
	if (pgi->nInput==1) { nCurrent=pgi->nConst; }

	pTempCheatInfo=pCheatInfo;

	if (nDIPSWCount) a=3; // skip the DIPSWes

	// find our thing
	for(i=1;i<(nInpcX1Input+nCheatCount+a-nGameInpCount+1);i++)
		pTempCheatInfo = pTempCheatInfo->pNext;
	// add the CheatChoice stuff onto the combo-box
	CheatChoice *pTempCheatChoice = pTempCheatInfo->pCheatChoice;
	while (pTempCheatChoice!=NULL)
	{
		SendMessage(hValue,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)pTempCheatChoice->szChoiceName);
		pTempCheatChoice = pTempCheatChoice->pNext;
	}
	// select the previous choice automatically
	SendMessage(hValue,CB_SETCURSEL,pTempCheatInfo->nEnabled,0);

	return 0;
}

static int InpcX1Exit()
{
	pgi=NULL;
	hValue=NULL;
	hInpcX1Dlg=NULL;
	return 0;
}

static BOOL CALLBACK DialogProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	(void)lParam; (void)wParam; (void)hDlg;
	if (Msg==WM_INITDIALOG) { hInpcX1Dlg=hDlg; InpcX1Init(); return 1; } // 1 = we didn't set focus?
	if (Msg==WM_CLOSE) { DestroyWindow(hInpcX1Dlg); return 0; }
	if (Msg==WM_DESTROY) { InpcX1Exit(); return 0; }

	if (Msg==WM_COMMAND)
	{
		int Id=LOWORD(wParam); int Notify=HIWORD(wParam);
		if (Id==IDOK     && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // OK=close
		if (Id==IDCANCEL && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // cancel=close

		if (Id==IDC_INPCX1_VALUE && Notify==CBN_SELCHANGE)
		{
			int i;
			if (pgi==NULL) return 0;
			int nSel = SendMessage(hValue,CB_GETCURSEL,0,0);
			pTempCheatInfo->nEnabled=(unsigned char)nSel;
			if (nSel)
			{
				CheatChoice *pTempCheatChoice = pTempCheatInfo->pCheatChoice;
				// move to the correct choice
				for (i=0;i<nSel;i++)
				{
					pTempCheatChoice = pTempCheatChoice->pNext;
				}
				pTempCheatInfo->nMemLocationToChange=pTempCheatChoice->nChoiceMemLocationToChange;
				for (i=0;i<pTempCheatInfo->nMemLocationToChange;i++)
				{

					pTempCheatInfo->nWriteValue[i]=pTempCheatChoice->nChoiceWriteValue[i];
					pTempCheatInfo->nCPS2MemLocation[i]=pTempCheatChoice->nChoiceCPS2MemLocation[i];
				}
			}
			// update
			pgi->nInput=1;
			pgi->nConst=pTempCheatInfo->nEnabled;
			InpCheatListMake(0);
			return 0;
		}
	}
	return 0;
}

int InpcX1Create()
{
	DestroyWindow(hInpcX1Dlg); hInpcX1Dlg=NULL; // Make sure exitted
	DestroyWindow(hInpcX2Dlg); hInpcX2Dlg=NULL; // Make sure exitted

	hInpcX1Dlg=CreateDialog(hAppInst,MAKEINTRESOURCE(IDD_INPCX1),hInpCheatDlg,DialogProc);
	if (hInpcX1Dlg==NULL) return 1;

	WndInMid(hInpcX1Dlg,hInpCheatDlg);
	ShowWindow(hInpcX1Dlg,SW_NORMAL);
	return 0;
}
