// Insert at the end of DrvFrame() function in cps_run.cpp

#ifdef _DEBUG
	if (nInterrupt) {
		printf("Beam synchronized interrupt at line %2x.\r", nRasterline[nInterrupt]);
	} else {
		printf("Beam synchronized interrupt disabled.   \r");
	}

	extern int counter;
	if (counter) {
		printf("\nSlices start at: ");
		for (i = 0; i < MAX_RASTER + 2; i++) {
			printf("%2x ", nRasterline[i]);
		}
		printf("\n");
		for (i = 0; i < 0x80; i++) {
			if (*((unsigned short*)(CpsSaveReg[0] + i * 2)) != *((unsigned short*)(CpsSaveReg[nInterrupt] + i * 2))) {
				printf("Register %2x: %4x -> %4x\n", i * 2, *((unsigned short*)(CpsSaveReg[0] + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + i * 2)));
			}
		}
		printf("\n");
		for (i = 0; i < 0x010; i++) {
			if (CpsSaveFrg[0][i] != CpsSaveFrg[nInterrupt][i]) {
				printf("FRG %x: %02x -> %02x\n", i, CpsSaveFrg[0][i], CpsSaveFrg[nInterrupt][i]);
			}
		}
		printf("\n");
		if (((CpsSaveFrg[0][4] << 8) | CpsSaveFrg[0][5]) != ((CpsSaveFrg[nInterrupt][4] << 8) | CpsSaveFrg[nInterrupt][5])) {
			printf("Layer-sprite priority: %04x -> %04x\n", ((CpsSaveFrg[0][4] << 8) | CpsSaveFrg[0][5]), ((CpsSaveFrg[nInterrupt][4] << 8) | CpsSaveFrg[nInterrupt][5]));
		}

		printf("\n");
		for (i = 0; i < 0x080; i+= 8) {
			printf("%2x: %4x %4x %4x %4x %4x %4x %4x %4x\n", i * 2, *((unsigned short*)(CpsSaveReg[nInterrupt] + 0 + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + 2 + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + 4 + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + 6 + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + 8 + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + 10 + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + 12 + i * 2)), *((unsigned short*)(CpsSaveReg[nInterrupt] + 14 + i * 2)));
		}
		printf("\nFRG: ");
		for (i = 0; i < 0x010; i++) {
			printf("%02x ", CpsSaveFrg[nInterrupt][i]);
		}
		printf("\n");

		extern int bRunPause;
		bRunPause = 1;
		counter = 0;
	}
#endif


