#include "cps.h"
// Quiz & Dragons - All-in-One Driver 1.21 by Mike_Haggar_99@hotmail.com
// Load menu display adjustment by LoopMaster
// Cheat engine source by HyperYagami
// Renamed button by Bigfool


static struct BurnInputInfo DrvInputList[]=
{
  {"P1 Coin"       , 0, CpsInp018+0, "p1 coin"},
  {"P1 Start"      , 0, CpsInp018+4, "p1 start"},
  {"P1 Up"         , 0, CpsInp001+3, "p1 up"},
  {"P1 Down"       , 0, CpsInp001+2, "p1 down"},
  {"P1 Left"       , 0, CpsInp001+1, "p1 left"},
  {"P1 Right"      , 0, CpsInp001+0, "p1 right"},
  {"P1 Answer 1"   , 0, CpsInp001+4, "p1 fire 1"},
  {"P1 Answer 2"   , 0, CpsInp001+5, "p1 fire 2"},
  {"P1 Answer 3"   , 0, CpsInp001+6, "p1 fire 3"},
  {"P1 Answer 4"   , 0, CpsInp001+7, "p1 fire 4"},

  {"P2 Coin"       , 0, CpsInp018+1, "p2 coin"},
  {"P2 Start"      , 0, CpsInp018+5, "p2 start"},
  {"P2 Up"         , 0, CpsInp000+3, "p2 up"},
  {"P2 Down"       , 0, CpsInp000+2, "p2 down"},
  {"P2 Left"       , 0, CpsInp000+1, "p2 left"},
  {"P2 Right"      , 0, CpsInp000+0, "p2 right"},
  {"P2 Answer 1"   , 0, CpsInp000+4, "p2 fire 1"},
  {"P2 Answer 2"   , 0, CpsInp000+5, "p2 fire 2"},
  {"P2 Answer 3"   , 0, CpsInp000+6, "p2 fire 3"},
  {"P2 Answer 4"   , 0, CpsInp000+7, "p2 fire 4"},
  {"Service"       , 0, CpsInp018+2, "service"},

  {"Reset"         , 0, &CpsReset,   "reset"},
  {"Diagnostic"    , 0, CpsInp018+6, "diag"},
};

// Return 0 if a input number is defined, and (if pii!=NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nDrvCount=0;
  nDrvCount=sizeof(DrvInputList) /sizeof(DrvInputList[0]);
  if (i<nDrvCount) { if (pii!=NULL) *pii=DrvInputList[i];  return 0; }
  else SETUP_THE_CHEAT_LIST
  else SETUP_THE_DIPSW_LIST
  return 1;
}

static int DrvScode(unsigned int n)
{
  if (n>=0x20 && n<=0x4b) return 2;
  if (n>=0x9d && n<=0xc8) return 2;
  return 1;
}

static int DrvExit()
{

  DestroyCheatList();
  DestroyDIPSWList();

  CpsRunExit();
  BurnScode=NULL;
  nPsndIrqPeriod=0; //OLDTST

  CpsExit();
  nCpsAdLen=0; nCpsZRomLen=0; nCpsGfxLen=0; nCpsRomLen=0;
  Cps=0; Qad=0;
  return 0;
}

static int DrvFrame()
{
  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  CpsFsStopOpposite(); // stop opposite directions
  // Carry on to CPS frame
  Cps1Frame();
  return 0;
}

//====================
//Quiz & Dragons (USA)
//====================

static int QadInit()
{
  int nRet=0;
  Cps=1; Qad=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 4*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000001,0,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x000000,1,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040001,2,2); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x040000,3,2); if (nRet!=0) return 1;
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTilesByte(CpsGfx, 4);

  nCpsLcReg=0x6c; // Layer control register is at 0x6c
  CpsLayEn[1]=0x14;
  CpsLayEn[2]=0x02;
  CpsLayEn[3]=0x14;

  // Protection enable code by KEV
  CpsMProt[0]=0x00;
  CpsMProt[1]=0x00;
  CpsMProt[2]=0x00;
  CpsMProt[3]=0x00;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,12,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,13,1);
  nRet=BurnLoadRom(CpsAd+0x20000,14,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

// Count possible zip names and (if pszName!=NULL) return them
static int QadZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="qad.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo QadRomDesc[]=
{
  {"qdu_36a.rom" ,0x20000,0xde9c24a0,0x10}, // 0 even 68000 code
  {"qdu_42a.rom" ,0x20000,0xcfe36f0c,0x10}, // 1 odd
  {"qdu_37a.rom" ,0x20000,0x10d22320,0x10}, // 2 even 68000 code
  {"qdu_43a.rom" ,0x20000,0x15e6beb9,0x10}, // 3 odd

  // graphics:
  {"qdu_09.rom",0x20000,0x8c3f9f44,   1}, // 4
  {"qdu_01.rom",0x20000,0xf688cf8f,   1},
  {"qdu_13.rom",0x20000,0xafbd551b,   1},
  {"qdu_05.rom",0x20000,0xc3db0910,   1},
  {"qdu_24.rom",0x20000,0x2f1bd0ec,   1}, // 8
  {"qdu_17.rom",0x20000,0xa812f9e2,   1},
  {"qdu_38.rom",0x20000,0xccdddd1f,   1},
  {"qdu_32.rom",0x20000,0xa8d295d3,   1},

  // z80 rom
  {"qdu_23.rom" ,0x10000,0xcfb5264b,   1}, // 12
  // samples
  {"qdu_30.rom" ,0x20000,0xf190da84,   1},
  {"qdu_31.rom" ,0x20000,0xb7583f73,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Qad) STD_ROM_FN(Qad)

struct BurnDriver BurnDrvCpsQad=
{
  {"qad","Quiz & Dragons (USA)","","Capcom","CPS1","1992",NULL},
  1,2,HARDWARE_CAPCOM_CPS1,
  QadZipName,QadRomInfo,QadRomName,DrvInputInfo,
  QadInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//======================
//Quiz & Dragons (Japan)
//======================

static int QadjInit()
{
  int nRet=0;
  Cps=1; Qad=1;
  nCpsRomLen=   0x100000;
  nCpsCodeLen=0; // not encrypted
  nCpsGfxLen= 4*0x080000;
  nCpsZRomLen=  0x010000;
  nCpsAdLen  =2*0x020000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  // Load program roms
  nRet=BurnLoadRom(CpsRom+0x000000,0,1); if (nRet!=0) return 1;
  nRet=BurnLoadRom(CpsRom+0x080000,1,1); if (nRet!=0) return 1;
  // Set dip switches
  SETUP_DIPSW_3(Cpi01A,Cpi01C,Cpi01E,0x00,0x03,0x60);
  // Load graphics roms
  CpsLoadTiles(CpsGfx         ,2);

  nCpsLcReg=0x66; // Layer control register is at 0x66
  CpsLayEn[1]=0x02; 
  CpsLayEn[2]=0x04; 
  CpsLayEn[3]=0x08; 

  // Protection enable code by KEV
  CpsMProt[0]=0x40;
  CpsMProt[1]=0x42;
  CpsMProt[2]=0x44;
  CpsMProt[3]=0x46;

  // Load Z80 Rom
  nRet=BurnLoadRom(CpsZRom,6,1);
  nPsndIrqPeriod=(60<<10)/250; //OLDTST
  BurnScode=DrvScode;

  // Load ADPCM data
  nRet=BurnLoadRom(CpsAd        ,7,1);
  nRet=BurnLoadRom(CpsAd+0x20000,8,1);

  ConstructCheatList();
  ConstructDIPSWList();

  nRet=CpsRunInit(); if (nRet!=0) return 1;
  // Ready to go
  return 0;
}

// Count possible zip names and (if pszName!=NULL) return them
static int QadjZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="qad.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="qadj.zip"; return 0; }
  return 1;
}

// Rom information
static struct StdRomInfo QadjRomDesc[]=
{
  {"qad23a.bin" ,0x80000,0x4d3553de,0x10}, // 0 both 68000 code
  {"qad22a.bin" ,0x80000,0x3191ddd0,0x10}, // 1 both

  // graphics:
  {"qad01.bin",0x80000,0x9d853b57,   1}, // 2
  {"qad02.bin",0x80000,0xb35976c4,   1},
  {"qad03.bin",0x80000,0xcea4ca8c,   1},
  {"qad04.bin",0x80000,0x41b74d1b,   1},

  // z80 rom
  {"qad09.bin" ,0x10000,0x733161cc,   1}, // 6
  // samples
  {"qad18.bin" ,0x20000,0x2bfe6f6a,   1},
  {"qad19.bin" ,0x20000,0x13d3236b,   1},
};

// Make The RomInfo/Name functions for the game
STD_ROM_PICK(Qadj) STD_ROM_FN(Qadj)

struct BurnDriver BurnDrvCpsQadj=
{
  {"qadj","Quiz & Dragons (Japan)","","Capcom","CPS1","1992","qad"},
  1,2,HARDWARE_CAPCOM_CPS1,
  QadjZipName,QadjRomInfo,QadjRomName,DrvInputInfo,
  QadjInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

