#include "cps.h"
// Street Fighter Alpha 2 - All-in-One Driver 1.34
// Added Battle Time cheat - Mike_Haggar_99@hotmail.com
// Cheat engine source by HyperYagami
// Asia clone added and re-name of some Japanese program roms - Treble Winner


static unsigned char bStopMusicTimeout=1;


static int DrvInputInfo(struct BurnInputInfo *pii,unsigned int i)
{
  unsigned int nCpsCount=0,nDrvCount=0;

  nCpsCount=sizeof(CpsFsi)/sizeof(CpsFsi[0]);
  if (i<nCpsCount) { if (pii!=NULL) *pii=CpsFsi[i];  return 0; }
  i-=nCpsCount;

  // HyperYagami: cheats
  SETUP_THE_CHEAT_LIST

  return 1;
}

static int DrvScode(unsigned int n) { if (n<=0x3f) return 2;  return 1; }

static int DrvInit()
{
  int nRet=0; int i=0; unsigned char *pqs=NULL;

  Cps=2;
  nCpsRomLen=  6*0x080000;
  nCpsCodeLen= 2*0x080000;
  nCpsGfxLen=   0x1400000;
  nCpsZRomLen= 2*0x020000;
  nCpsQSamLen= 2*0x200000;
  nRet=CpsInit(); if (nRet!=0) return 1;

  for (i=0;i<6;i++)
  { nRet=BurnLoadRom(CpsRom+0x080000*i,2+i,1); if (nRet!=0) return 1; }

  memcpy(CpsCode,CpsRom,nCpsCodeLen);
  nRet=BurnXorRom(CpsCode         ,0,1); if (nRet!=0) return 1;
  nRet=BurnXorRom(CpsCode+0x080000,1,1); if (nRet!=0) return 1;

  nRet=Cps2LoadTiles(CpsGfx           , 8);
  nRet=Cps2LoadTiles(CpsGfx+4*0x400000,12);

  nRet=BurnLoadRom(CpsZRom         ,16,1);
  nRet=BurnLoadRom(CpsZRom+ 0x20000,17,1);

  pqs=(unsigned char *)CpsQSam;
  nRet=BurnLoadRom(pqs         ,18,1);
  nRet=BurnLoadRom(pqs+0x200000,19,1);
  BurnByteswap(pqs,nCpsQSamLen);
  BurnScode=DrvScode;

ConstructCheatList();
  nRet=CpsRunInit(); if (nRet!=0) return 1;

  return 0;
}

static int DrvExit()
{

DestroyCheatList();

  CpsRunExit();
  BurnScode=NULL;
  CpsExit();
  nCpsQSamLen=0;
  nCpsZRomLen=0;
  nCpsGfxLen=0;
  nCpsCodeLen=0;
  nCpsRomLen=0;
  Cps=0;
  return 0;
}

static int DrvFrame()
{

  // HyperYagami: cheats
APPLY_CHEATS(CpsRamFF)

  unsigned int *TimeOut=NULL; unsigned int OldTimeOut=0;

  TimeOut=(unsigned int *)(CpsCode+0x8cbda);
  OldTimeOut=TimeOut[0];
  if (bStopMusicTimeout) TimeOut[0]=0x4e714e71;

  CpsFsAllThree();
  CpsFsStopOpposite();

  Cps2Frame();

  TimeOut[0]=OldTimeOut;
  return 0;
}

//============================
//Street Fighter Alpha 2 (USA)
//============================

static int Sfa2ZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sfa2.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sfa2RomDesc[]=
{
  {"sz2ux.03",0x80000,0x6bb6005f, 0x10},
  {"sz2ux.04",0x80000,0x74308a4b, 0x10},

  {"sz2u.03" ,0x80000,0x84a09006, 0x10},
  {"sz2u.04" ,0x80000,0xac46e5ed, 0x10},
  {"sz2u.05" ,0x80000,0x6c0c79d3, 0x10},
  {"sz2u.06" ,0x80000,0xc5c8eb63, 0x10},
  {"sz2u.07" ,0x80000,0x5de01cc5, 0x10},
  {"sz2u.08" ,0x80000,0xbea11d56, 0x10},

  {"sz2.13"  ,0x400000,0x4d1f1f22,    1},
  {"sz2.15"  ,0x400000,0x19cea680,    1},
  {"sz2.17"  ,0x400000,0xe01b4588,    1},
  {"sz2.19"  ,0x400000,0x0feeda64,    1},
  {"sz2.14"  ,0x100000,0x0560c6aa,    1},
  {"sz2.16"  ,0x100000,0xae940f87,    1},
  {"sz2.18"  ,0x100000,0x4bc3c8bc,    1},
  {"sz2.20"  ,0x100000,0x39e674c0,    1},

  {"sz2.01a"  ,0x020000,0x1bc323cf,    2},
  {"sz2.02a"  ,0x020000,0xba6a5013,    2},

  {"sz2.11"  ,0x200000,0xaa47a601,    2},
  {"sz2.12"  ,0x200000,0x2237bc53,    2},
};

STD_ROM_PICK(Sfa2) STD_ROM_FN(Sfa2)

struct BurnDriver BurnDrvCpsSfa2=
{
  {"sfa2" ,"Street Fighter Alpha 2 (USA)","","Capcom","CPS2","1996",NULL},
  1,2,HARDWARE_CAPCOM_CPS2,
  Sfa2ZipName, Sfa2RomInfo, Sfa2RomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//===================================
//Street Fighter Zero 2 Alpha (Japan)
//===================================

static int Sfz2ajZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sfa2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sfz2aj.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sfz2ajRomDesc[]=
{
  {"szajx.03a",0x80000,0x6d3aa71e, 0x10}, // xor decryption table
  {"szajx.04a",0x80000,0x006d5cb8, 0x10}, // xor decryption table

  {"szaj.03a" ,0x80000,0xa3802fe3, 0x10}, // 68000 code (encrypted)
  {"szaj.04a" ,0x80000,0xe7ca87c7, 0x10},
  {"szaj.05a" ,0x80000,0xc88ebf88, 0x10},
  {"szaj.06a" ,0x80000,0x35ed5b7a, 0x10},
  {"szaj.07a" ,0x80000,0x975dcb3e, 0x10},
  {"szaj.08a" ,0x80000,0xdc73f2d7, 0x10},

  {"sz2.13"  ,0x400000,0x4d1f1f22,    1}, // 8
  {"sz2.15"  ,0x400000,0x19cea680,    1},
  {"sz2.17"  ,0x400000,0xe01b4588,    1},
  {"sz2.19"  ,0x400000,0x0feeda64,    1},
  {"sz2.14"  ,0x100000,0x0560c6aa,    1},
  {"sz2.16"  ,0x100000,0xae940f87,    1},
  {"sz2.18"  ,0x100000,0x4bc3c8bc,    1},
  {"sz2.20"  ,0x100000,0x39e674c0,    1},

  {"sz2.01a"  ,0x020000,0x1bc323cf,    2}, // 16
  {"sz2.02a"  ,0x020000,0xba6a5013,    2},
  // sound - samples
  {"sz2.11"  ,0x200000,0xaa47a601,    2},
  {"sz2.12"  ,0x200000,0x2237bc53,    2},
};

STD_ROM_PICK(Sfz2aj) STD_ROM_FN(Sfz2aj)

struct BurnDriver BurnDrvCpsSfz2aj=
{
  {"sfz2aj" ,"Street Fighter Zero 2 Alpha (Japan)","","Capcom","CPS2","1996","sfa2"},
  1,2,HARDWARE_CAPCOM_CPS2,
  Sfz2ajZipName, Sfz2ajRomInfo, Sfz2ajRomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//=============================
//Street Fighter Zero 2 (Japan)
//=============================

static int Sfz2jZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sfa2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sfz2j.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sfz2jRomDesc[]=
{
  {"sz2jx.03a",0x80000,0x6a765c08, 0x10},
  {"sz2jx.04a",0x80000,0x66139273, 0x10},

  {"sz2j.03a" ,0x80000,0x97461e28, 0x10},
  {"sz2j.04a" ,0x80000,0xae4851a9, 0x10},
  {"sz2.05"   ,0x80000,0x98e8e992, 0x10},
  {"sz2.06"   ,0x80000,0x5b1d49c0, 0x10},
  {"sz2j.07a" ,0x80000,0xd910b2a2, 0x10},
  {"sz2.08"   ,0x80000,0x0fe8585d, 0x10},
 
  {"sz2.13"  ,0x400000,0x4d1f1f22,    1},
  {"sz2.15"  ,0x400000,0x19cea680,    1},
  {"sz2.17"  ,0x400000,0xe01b4588,    1},
  {"sz2.19"  ,0x400000,0x0feeda64,    1},
  {"sz2.14"  ,0x100000,0x0560c6aa,    1},
  {"sz2.16"  ,0x100000,0xae940f87,    1},
  {"sz2.18"  ,0x100000,0x4bc3c8bc,    1},
  {"sz2.20"  ,0x100000,0x39e674c0,    1},

  {"sz2.01a"  ,0x020000,0x1bc323cf,    2},
  {"sz2.02a"  ,0x020000,0xba6a5013,    2},

  {"sz2.11"  ,0x200000,0xaa47a601,    2},
  {"sz2.12"  ,0x200000,0x2237bc53,    2},
};

STD_ROM_PICK(Sfz2j) STD_ROM_FN(Sfz2j)

struct BurnDriver BurnDrvCpsSfz2j=
{
  {"sfz2j" ,"Street Fighter Zero 2 (Japan)","","Capcom","CPS2","1996","sfa2"},
  1,2,HARDWARE_CAPCOM_CPS2,
  Sfz2jZipName, Sfz2jRomInfo, Sfz2jRomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};

//============================
//Street Fighter Zero 2 (Asia)
//============================

static int Sfz2aZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="sfa2.zip"; return 0; }
  if (i==1) { if (pszName!=NULL) *pszName="sfz2a.zip"; return 0; }
  return 1;
}

static struct StdRomInfo Sfz2aRomDesc[]=
{
  {"sz2ax.03a",0x80000,0xb76d8578, 0x10},
  {"sz2ax.04a",0x80000,0xd4dc0b1e, 0x10},

  {"sz2a.03a" ,0x80000,0x30d2099f, 0x10},
  {"sz2a.04a" ,0x80000,0x1cc94db1, 0x10},
  {"sz2.05"   ,0x80000,0x98e8e992, 0x10},
  {"sz2.06"   ,0x80000,0x5b1d49c0, 0x10},
  {"sz2a.07a" ,0x80000,0x0aed2494, 0x10},
  {"sz2.08"   ,0x80000,0x0fe8585d, 0x10},
 
  {"sz2.13"  ,0x400000,0x4d1f1f22,    1},
  {"sz2.15"  ,0x400000,0x19cea680,    1},
  {"sz2.17"  ,0x400000,0xe01b4588,    1},
  {"sz2.19"  ,0x400000,0x0feeda64,    1},
  {"sz2.14"  ,0x100000,0x0560c6aa,    1},
  {"sz2.16"  ,0x100000,0xae940f87,    1},
  {"sz2.18"  ,0x100000,0x4bc3c8bc,    1},
  {"sz2.20"  ,0x100000,0x39e674c0,    1},

  {"sz2.01a"  ,0x020000,0x1bc323cf,    2},
  {"sz2.02a"  ,0x020000,0xba6a5013,    2},

  {"sz2.11"  ,0x200000,0xaa47a601,    2},
  {"sz2.12"  ,0x200000,0x2237bc53,    2},
};

STD_ROM_PICK(Sfz2a) STD_ROM_FN(Sfz2a)

struct BurnDriver BurnDrvCpsSfz2a=
{
  {"sfz2a" ,"Street Fighter Zero 2 (Asia)","","Capcom","CPS2","1996","sfa2"},
  1,2,HARDWARE_CAPCOM_CPS2,
  Sfz2aZipName, Sfz2aRomInfo, Sfz2aRomName, DrvInputInfo,
  DrvInit,DrvExit,DrvFrame,CpsRedraw,CpsAreaScan,
  &CpsRecalcPal,384,224,4,3
};