// Burner Cheat Dialog module
// By HyperYagami, based on the original code (inpd.cpp) by dayvee
#include "app.h"
#include "cheat.h"

HWND hInpCheatDlg=NULL; // Handle to the Cheat Dialog
static HWND hInpCheatList=NULL;

// Update
static int InpCheatUseUpdate()
{
	unsigned int i=0,a=0; struct GameInp *pgi=NULL;
	struct CheatInfo* pTempCheatInfo = pCheatInfo;

	if (hInpCheatList==NULL) return 1;

	// Update the values of all the cheats
	// We want to skip the inputs
	if (nDIPSWCount) a=3; // skip the DIPSWes
	for (i=0,pgi=GameInp+(nGameInpCount-nCheatCount-a); i<nCheatCount; i++,pgi++)
	{
		LVITEM LvItem;
		char *pszVal=NULL;

		if (pTempCheatInfo->nCheatType==1)
		{
			struct CheatChoice* pTempCheatChoice=pTempCheatInfo->pCheatChoice;
			for (int j=0;j<pTempCheatInfo->nEnabled;j++) pTempCheatChoice=pTempCheatChoice->pNext;
			pszVal=pTempCheatChoice->szChoiceName;
		}
		else if (pTempCheatInfo->nCheatType==2)
		{
			(pTempCheatInfo->nEnabled)?pszVal="Enabled":pszVal="Disabled";
		}

		memset(&LvItem,0,sizeof(LvItem));
		LvItem.mask=LVIF_TEXT;
		LvItem.iItem=i;
		LvItem.iSubItem=1;
		LvItem.pszText=pszVal;

		SendMessage(hInpCheatList,LVM_SETITEM,0,(LPARAM)&LvItem);
		pTempCheatInfo=pTempCheatInfo->pNext;
	}
	return 0;
}

static int InpCheatListBegin()
{
	LVCOLUMN LvCol;
	if (hInpCheatList==NULL) return 1;
	// Full row select style:
	SendMessage(hInpCheatList,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT);

	// Make column headers
	memset(&LvCol,0,sizeof(LvCol));
	LvCol.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
	LvCol.cx=0xf0;
	LvCol.pszText="Cheat Name";
	SendMessage(hInpCheatList,LVM_INSERTCOLUMN,0,(LPARAM)&LvCol);

	LvCol.cx=0x94;
	LvCol.pszText="Current Value";
	SendMessage(hInpCheatList,LVM_INSERTCOLUMN,1,(LPARAM)&LvCol);

	return 0;
}

// Make a list view of the game cheats
int InpCheatListMake(int bBuild)
{
	unsigned int i=0,a=0;
	if (hInpCheatList==NULL) return 1;

	if (bBuild)
	{
		SendMessage(hInpCheatList,LVM_DELETEALLITEMS,0,0);
		// Add all the cheat names to the list
		// Skip the game inputs
		if (nDIPSWCount) a=3; // skip the DIPSWes
		for (i=(nGameInpCount-nCheatCount-a);i<(nGameInpCount-a);i++)
		{
			struct BurnInputInfo bii;
			LVITEM LvItem;

			// Get the name of the cheat
			bii.szName=NULL; BurnDrvGetInputInfo(&bii,i); if (bii.szName==NULL) bii.szName="";

			memset(&LvItem,0,sizeof(LvItem));
			LvItem.mask=LVIF_TEXT;
			LvItem.iItem=i;
			LvItem.iSubItem=0;
			LvItem.pszText=bii.szName;

			SendMessage(hInpCheatList,LVM_INSERTITEM,0,(LPARAM)&LvItem);
		}
	}

	InpCheatUseUpdate();
	return 0;
}

static int InpCheatInit()
{
	// Set the dialog title+label
	SetWindowText(hInpCheatDlg,"Edit Cheats");
	SetWindowText(GetDlgItem(hInpCheatDlg,IDC_PLEASE),"Double-click on a cheat to change it");

	hInpCheatList=GetDlgItem(hInpCheatDlg,IDC_INPCHEAT_LIST);
	InpCheatListBegin();
	InpCheatListMake(1);

	return 0;
}

static int InpCheatExit()
{
	hInpCheatList=NULL;
	hInpCheatDlg=NULL;
    if(!bAltPause && bRunPause) bRunPause=0;
	return 0;
}

static int ListItemActivate()
{
	struct BurnInputInfo bii; int nSel=0,a=0;
	// List item activated
	// Find out which one was activated
	nSel=SendMessage(hInpCheatList,LVM_GETNEXTITEM,(unsigned)-1,LVNI_SELECTED);
	if (nSel<0) return 1;
	if (nDIPSWCount) a=3; // skip the DIPSWes
	bii.nType=0; BurnDrvGetInputInfo(&bii,nSel+(nGameInpCount-nCheatCount-a));

	if (bii.nType==3)
	{
		nInpcX1Input=nSel+(nGameInpCount-nCheatCount-a);
		InpcX1Create();
	}
	else if (bii.nType==4)
	{
		nInpcX2Input=nSel+(nGameInpCount-nCheatCount-a);
		InpcX2Create();
	}
	return 0;
}

static BOOL CALLBACK DialogProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	(void)lParam; (void)wParam; (void)hDlg;
    if (Msg==WM_INITDIALOG) { hInpCheatDlg=hDlg; InpCheatInit(); return 1; } // 1 = we didn't set focus?
	if (Msg==WM_CLOSE) { DestroyWindow(hInpCheatDlg); return 0; }

	if (Msg==WM_DESTROY) { InpCheatExit(); return 0; }

	if (Msg==WM_COMMAND)
	{
		int Id=LOWORD(wParam); int Notify=HIWORD(wParam);

		if (Id==IDOK && Notify==BN_CLICKED) { ListItemActivate(); return 0;  }
		if (Id==IDCANCEL && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; }  // cancel=close
		if (Id==IDC_INPC_RESET && Notify==BN_CLICKED)
		{
			int nRet=0,a=0;
			AudSoundStop(); // stop while we display message box
			nRet=MessageBox(
				hDlg,"Reset all cheats?","Reset",
				MB_YESNO | MB_DEFBUTTON2 | MB_ICONWARNING);
			AudSoundPlay(); // restart sound
			if (nRet!=IDYES) return 0; // don't do it
			if (nDIPSWCount) a=3; // skip the DIPSWes
			struct GameInp *pgi=GameInp+(nGameInpCount-nCheatCount-a);
			struct CheatInfo* pTempCheatInfo=pCheatInfo;
			for (int i=0;i<nCheatCount; i++,pgi++)
			{
				pTempCheatInfo->nEnabled=0;
				pgi->nConst=0;
				pTempCheatInfo=pTempCheatInfo->pNext;
			}
			InpCheatListMake(0); // refresh view
			return 0;
		}
	}

	if (Msg==WM_NOTIFY && lParam!=0)
	{
		int Id=LOWORD(wParam); NMHDR *pnm=(NMHDR *)lParam;

		if (Id==IDC_INPCHEAT_LIST && pnm->code==LVN_ITEMACTIVATE)
		{
			ListItemActivate();
		}
		return 0;
	}

	return 0;
}

int InpCheatCreate()
{
	if (bDrvOkay==0) return 1; // No game is loaded

	DestroyWindow(hInpCheatDlg); // Make sure exitted

	hInpCheatDlg=CreateDialog(hAppInst,MAKEINTRESOURCE(IDD_INPCHEAT),hScrnWnd,DialogProc);
	if (hInpCheatDlg==NULL) return 1;

	WndInMid(hInpCheatDlg,hScrnWnd);
	ShowWindow(hInpCheatDlg,SW_NORMAL);
	bRunPause=1;
	return 0;
}
