// Burner Input Constant dialog module EXTENDED, Type 2
// By HyperYagami, based on the original code (inpc.cpp) by dayvee
#include "app.h"
#include "cheat.h"

HWND hInpcX2Dlg=NULL; // Handle to the Input Dialog
unsigned int nInpcX2Input=0; // The input number we are redefining
static struct CheatInfo *pTempCheatInfo;

static struct GameInp *pgi=NULL; // Current GameInp

static void RefreshPanel()
{
	CheckDlgButton(hInpcX2Dlg,IDC_RADIO_ENABLED,(pTempCheatInfo->nEnabled==1)?BST_CHECKED:BST_UNCHECKED);
	CheckDlgButton(hInpcX2Dlg,IDC_RADIO_DISABLED,(pTempCheatInfo->nEnabled==0)?BST_CHECKED:BST_UNCHECKED);
}


static int InpcX2Init()
{
	char szText[128]; int nCurrent=0;
	unsigned int i, a=0;

	struct BurnInputInfo bii; // Info about the input

	// Get the extra info about the input
	memset(&bii,0,sizeof(bii));
	BurnDrvGetInputInfo(&bii,nInpcX2Input);
	if (bii.szName==NULL) bii.szName="";

	// Set the dialog title
	sprintf(szText,"Edit %.100s",bii.szName);
	SetWindowText(hInpcX2Dlg,szText);

	pgi=NULL;
	if (nInpcX2Input>=nGameInpCount) return 1; // input out of range
	pgi=GameInp+nInpcX2Input;

	// Get current constant
	if (pgi->nInput==1) { nCurrent=pgi->nConst; }

	pTempCheatInfo=pCheatInfo;

	if (nDIPSWCount) a=3; // skip the DIPSWes

	// find our thing
	for(i=1;i<(nInpcX2Input+nCheatCount+a-nGameInpCount+1);i++)
		pTempCheatInfo = pTempCheatInfo->pNext;
	RefreshPanel();
	return 0;
}

static int InpcX2Exit()
{
	pgi=NULL;
	hInpcX2Dlg=NULL;
	return 0;
}

static BOOL CALLBACK DialogProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	(void)lParam; (void)wParam; (void)hDlg;
	if (Msg==WM_INITDIALOG) { hInpcX2Dlg=hDlg; InpcX2Init(); return 1; } // 1 = we didn't set focus?
	if (Msg==WM_CLOSE) { DestroyWindow(hInpcX2Dlg); return 0; }
	if (Msg==WM_DESTROY) { InpcX2Exit(); return 0; }

	if (Msg==WM_COMMAND)
	{
		int Id=LOWORD(wParam); int Notify=HIWORD(wParam);
		if (Id==IDOK     && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // OK=close
		if (Id==IDCANCEL && Notify==BN_CLICKED) { SendMessage(hDlg,WM_CLOSE,0,0); return 0; } // cancel=close

		if ((Id==IDC_RADIO_ENABLED)||(Id==IDC_RADIO_DISABLED))
		{
			if (pgi==NULL) return 0;
			if (Id==IDC_RADIO_ENABLED) pTempCheatInfo->nEnabled=0x01;
			else pTempCheatInfo->nEnabled=0;
			pgi->nInput=1;
			pgi->nConst=pTempCheatInfo->nEnabled;
			InpCheatListMake(0);
			RefreshPanel();
			return 0;
		}
	}
	return 0;
}

int InpcX2Create()
{
	DestroyWindow(hInpcX1Dlg); hInpcX1Dlg=NULL; // Make sure exitted
	DestroyWindow(hInpcX2Dlg); hInpcX2Dlg=NULL; // Make sure exitted

	hInpcX2Dlg=CreateDialog(hAppInst,MAKEINTRESOURCE(IDD_INPCX2),hInpCheatDlg,DialogProc);
	if (hInpcX2Dlg==NULL) return 1;

	WndInMid(hInpcX2Dlg,hInpCheatDlg);
	ShowWindow(hInpcX2Dlg,SW_NORMAL);
	return 0;
}
