//ayeye

#include "app.h"
#include <ctype.h>

int wDial=0;
char *frDial="Number of Frames";
char *chDial="Cheat Frequency";

static BOOL CALLBACK DefInpProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
  (void)lParam;
  int nRet=0;
  BOOL fTrue=FALSE;

  switch(Msg)
  {
	 case WM_INITDIALOG:
		 if(wDial==0) nRet=nDSoundSegCount;
		 else nRet=nApplyCheatEveryXFrame;
         SetWindowText(hDlg, wDial?chDial:frDial);
		 SetDlgItemInt(hDlg, IDC_VALUE_EDIT, nRet, TRUE);
		 SetFocus(hDlg); //Enable Esc=close
		 break;

	 case WM_COMMAND:
		 if(LOWORD(wParam)==ID_VALUE_CLOSE) SendMessage(hDlg,WM_CLOSE,0,0);
		 else if(HIWORD(wParam)==BN_CLICKED && LOWORD(wParam)==IDCANCEL) SendMessage(hDlg,WM_CLOSE,0,0);
		 break;

	 case WM_CLOSE:
         nRet = GetDlgItemInt(hDlg, IDC_VALUE_EDIT, &fTrue, TRUE);
		 if(fTrue && !wDial) nDSoundSegCount=nRet;
		 else nApplyCheatEveryXFrame=nRet;
		 EndDialog(hDlg,0);
  }

  return 0;
}

int NumDialCreate(int bDial)
{
  wDial=bDial;
  DialogBox(hAppInst,MAKEINTRESOURCE(IDD_VALUE),hScrnWnd,DefInpProc);
  return 1;
}

static BOOL CALLBACK GammaProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM)	// LPARAM lParam
{
	static float nPrevGamma;
	static bool bCancelled;

	switch(Msg) {
		case WM_INITDIALOG:
			char szText[16];
			int nPos;
			nPrevGamma = nGamma;
			bCancelled = 0;

			WndInMid(hDlg, hScrnWnd);

			// initialise gamma slider
			SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_SETRANGE, (WPARAM)0, (LPARAM)MAKELONG(1, 20000));
			SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_SETPAGESIZE, (WPARAM)0, (LPARAM)250);
			SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_SETTIC, (WPARAM)0, (LPARAM)7500);
			SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_SETTIC, (WPARAM)0, (LPARAM)10001);
			SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_SETTIC, (WPARAM)0, (LPARAM)12500);

			// Set slider to value of nGamma
			if (nGamma > 1.0) {		// Gamma > 1
				nPos = int((nGamma - 1.0f) * 10000.0f + 10001.0f);
			} else {				// Gamma < 1
				nPos = int(10000.0f - ((1.0f / nGamma) * 10000.0f - 10000.0f));
			}
			SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_SETPOS, (WPARAM)true, (LPARAM)nPos);

			// Set the edit control to the value of nGamma
			sprintf(szText, "%0.2f", nGamma);
			SendDlgItemMessage(hDlg, IDC_GAMMA_EDIT, WM_SETTEXT, (WPARAM)0, (LPARAM)szText);

			// Update the screen
			ComputeGammaLUT();
			if (bDrvOkay) {
				VidRedraw();
				VidPaint(0);
			}

			SetFocus(hDlg);
			break;

		case WM_COMMAND: {
			switch (HIWORD(wParam)) {
				case BN_CLICKED: {
					if (LOWORD(wParam) == IDCANCEL) {
						bCancelled = 1;
						nGamma = nPrevGamma;
						SendMessage(hDlg, WM_CLOSE, 0, 0);
					} else {
						if (LOWORD(wParam) == IDOK) {
							SendMessage(hDlg, WM_CLOSE, 0, 0);
						}
					}
					break;
				}
				case EN_UPDATE: {
					char szText[16] = "";
					bool bPoint = 0;
					bool bValid = 1;

					if (bCancelled) {
						break;
					}

					if (SendDlgItemMessage(hDlg, IDC_GAMMA_EDIT, WM_GETTEXTLENGTH, (WPARAM)0, (LPARAM)0) < 16) {
						SendDlgItemMessage(hDlg, IDC_GAMMA_EDIT, WM_GETTEXT, (WPARAM)16, (LPARAM)szText);
					}

					// Scan string in the edit control for illegal characters
					for (int i = 0; szText[i]; i++) {
						if (szText[i] == '.') {
							if (bPoint) {
								bValid = 0;
								break;
							}
						} else {
							if (!isdigit(szText[i])) {
								bValid = 0;
								break;
							}
						}
					}

					if (bValid) {
	    				nGamma = atof(szText);

						// Set slider to value of nGamma
						if (nGamma > 1.0) {		// Gamma > 1
							nPos = int((nGamma - 1.0f) * 10000.0f + 10001.0f);
						} else {				// Gamma < 1
							nPos = int(10000.0f - ((1.0f / nGamma) * 10000.0f - 10000.0f));
						}
						SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_SETPOS, (WPARAM)true, (LPARAM)nPos);
					}
					break;
				}
				break;
			}
		}

		case WM_HSCROLL: {
			switch (LOWORD(wParam)) {
				case TB_BOTTOM:
				case TB_ENDTRACK:
				case TB_LINEDOWN:
				case TB_LINEUP:
				case TB_PAGEDOWN:
				case TB_PAGEUP:
				case TB_THUMBPOSITION:
				case TB_THUMBTRACK:
				case TB_TOP: {
					char szText[16];

					if (bCancelled) {
						break;
					}

					// Update the contents of the edit control
					int nPos = SendDlgItemMessage(hDlg, IDC_GAMMA_SLIDER, TBM_GETPOS, (WPARAM)0, (LPARAM)0);
					if (nPos > 10000) {	// Gamma > 1
						nGamma = (float)(1.0 + (nPos - 10000.0) / 10000.0);
					} else {			// Gamma < 1
						nGamma = (float)(1.0 / (1.0 + ((10001.0 - nPos) / 10000.0)));
					}
					sprintf(szText, "%0.2f", nGamma);
					SendDlgItemMessage(hDlg, IDC_GAMMA_EDIT, WM_SETTEXT, (WPARAM)0, (LPARAM)szText);

					// Update the screen
					ComputeGammaLUT();
					if (bDrvOkay) {
						VidRedraw();
						VidPaint(0);
					}
					break;
				}
			}
			break;
		}

		case WM_CLOSE:
			EndDialog(hDlg, 0);
  }

  return 0;
}

void GammaDialog()
{
	DialogBox(hAppInst, MAKEINTRESOURCE(IDD_GAMMA), hScrnWnd, GammaProc);
}

static BOOL CALLBACK AbProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
  (void)lParam; (void)wParam;

  if (Msg == WM_INITDIALOG) {
	char szVerString[128];
	if ((nBurnVer & 0xFFFF) > 0x9990) {

		int nVer1 = ((nBurnVer >> 16) & 0xFF) + 1;
		if ((nVer1 & 0x0F) > 9) {
			nVer1 += 6;
		}
		int nVer2 = nVer1 & 0x0F;
		nVer1 >>= 4;

		sprintf(szVerString, "%s (v%i.%i Release Candidate %i)", szAppBurnVer, nVer1, nVer2, nBurnVer & 0x0F);
	} else {
		if (nBurnVer & 0x00FF) {
			sprintf(szVerString, "%s (alpha version)", szAppBurnVer);
		} else {
			if (nBurnVer & 0xFF00) {
				sprintf(szVerString, "%s (beta version)", szAppBurnVer);
			} else {
				sprintf(szVerString, "%s", szAppBurnVer);
			}
		}
	}
	SetDlgItemText(hDlg, IDC_FBA_VER, szVerString);
	SetFocus(hDlg);										// Enable Esc=close
  }
  if (Msg == WM_CLOSE) EndDialog(hDlg,0);
  if (Msg == WM_COMMAND && HIWORD(wParam) == BN_CLICKED && LOWORD(wParam) == IDCANCEL) SendMessage(hDlg,WM_CLOSE,0,0);
  return 0;
}


int AboutCreate()
{
  DialogBox(hAppInst,MAKEINTRESOURCE(IDD_ABOUT),hScrnWnd,AbProc);
  return 1;
}
