//ayeye

#include "app.h"
#include <shlobj.h>


HWND hRomsDlg=NULL;
DWORD dwScanThreadId=0;
HANDLE hScanThread=NULL;
int nOldSelect=0;
char *szRomName[BZIP_MAX*4];
BOOL gameAv[MAX_GAMES];
BOOL avOk=FALSE;
int bAvbOnly=1;

static char szRomDat[EXE_NAME_SIZE + 16];

static void CreateRomDatName()
{
	memcpy(szRomDat, "cfg\\", 4);
	memcpy(szRomDat + 4, szAppExeName, strlen(szAppExeName));
	memcpy(szRomDat + 4 + strlen(szAppExeName), ".roms.dat", 10);

	return;
}

//Select Directory Dialog//////////////////////////////////////////////////////////////////////////

static BOOL CALLBACK DefInpProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
  (void)lParam;
  int var, nRet, strLen=0;
  BROWSEINFO bInfo;
  ITEMIDLIST* pItemIDList = NULL;
  char buffer[MAX_PATH];
  BOOL chOk;

  switch(Msg)
  {
	 case WM_INITDIALOG:
		 SetDlgItemText(hDlg, IDC_ROMSDIR_EDIT1, szAppRomPath1);
		 SetDlgItemText(hDlg, IDC_ROMSDIR_EDIT2, szAppRomPath2);
		 SetDlgItemText(hDlg, IDC_ROMSDIR_EDIT3, szAppRomPath3);
		 SetDlgItemText(hDlg, IDC_ROMSDIR_EDIT4, szAppRomPath4);
		 SetFocus(hDlg); //Enable Esc=close
		 break;

	 case WM_COMMAND:

		 if(LOWORD(wParam)==ID_ROMSDIR_CLOSE) { SendMessage(hDlg,WM_CLOSE,0,0); break; }
		 else if(LOWORD(wParam)==IDC_ROMSDIR_BR1) var=IDC_ROMSDIR_EDIT1;
		 else if(LOWORD(wParam)==IDC_ROMSDIR_BR2) var=IDC_ROMSDIR_EDIT2;
		 else if(LOWORD(wParam)==IDC_ROMSDIR_BR3) var=IDC_ROMSDIR_EDIT3;
		 else if(LOWORD(wParam)==IDC_ROMSDIR_BR4) var=IDC_ROMSDIR_EDIT4;
		 else if(HIWORD(wParam)==BN_CLICKED && LOWORD(wParam)==IDCANCEL) { SendMessage(hDlg,WM_CLOSE,0,0); break; }
		 else break;

		 memset(&bInfo, 0, sizeof(bInfo));
		 bInfo.hwndOwner=hDlg;
		 bInfo.pszDisplayName=buffer;
		 bInfo.lpszTitle="Select Directory:";
		 bInfo.ulFlags=BIF_RETURNONLYFSDIRS;

		 pItemIDList = SHBrowseForFolder(&bInfo);

         if(pItemIDList != NULL)
		 {
			 if(SHGetPathFromIDList(pItemIDList, buffer))
			 {
				 strLen=lstrlen(buffer);
				 if(strLen)
				 {
					 if(buffer[strLen-1]!='\\') { buffer[strLen]='\\'; buffer[strLen+1]='\0'; }
				 	 SetDlgItemText(hDlg, var, buffer);
				 }
			 }
		 }
         break;


	 case WM_CLOSE:
		 chOk=FALSE;
         nRet = GetDlgItemText(hDlg, IDC_ROMSDIR_EDIT1, buffer, sizeof(buffer));
		 if(nRet!=0 && lstrcmp( szAppRomPath1, buffer)!=0) { chOk=TRUE; lstrcpy(szAppRomPath1, buffer); }
		 nRet = GetDlgItemText(hDlg, IDC_ROMSDIR_EDIT2, buffer, sizeof(buffer));
		 if(nRet!=0 && lstrcmp( szAppRomPath2, buffer)!=0) { chOk=TRUE; lstrcpy(szAppRomPath2, buffer); }
		 nRet = GetDlgItemText(hDlg, IDC_ROMSDIR_EDIT3, buffer, sizeof(buffer));
		 if(nRet!=0 && lstrcmp( szAppRomPath3, buffer)!=0) { chOk=TRUE; lstrcpy(szAppRomPath3, buffer); }
		 nRet = GetDlgItemText(hDlg, IDC_ROMSDIR_EDIT4, buffer, sizeof(buffer));
		 if(nRet!=0 && lstrcmp( szAppRomPath4, buffer)!=0) { chOk=TRUE; lstrcpy(szAppRomPath4, buffer); }
		 EndDialog(hDlg,0);
		 if(chOk) { bRescanRoms=TRUE; TestRomsCreate(); }

  }

  return 0;
}


int RomsDirCreate()
{
  DialogBox(hAppInst,MAKEINTRESOURCE(IDD_ROMSDIR),hScrnWnd,DefInpProc);
  return 1;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//Check Romsets Dialog/////////////////////////////////////////////////////////////////////////////

int WriteGameAvb()
{
  FILE *h=NULL;
  int i;

  CreateRomDatName();

  h=fopen(szRomDat,"wt");
  if (h==NULL) return 1;

  fprintf(h,"FBA%sROMS", szAppBurnVer);

  for(i=0; i<MAX_GAMES; i++)
  {
    if(gameAv[i]) fputc('a', h);
	else fputc('n', h);
  }

  fprintf(h,"FBA%sROMS", szAppBurnVer);
  fclose(h);

  return 0;
}

int CheckGameAvb()
{
  FILE *h=NULL;
  static char buffer[MAX_GAMES+50];
  static char label[15];
  char *buffPos;
  int i;
  buffer[0]=0;

  CreateRomDatName();

  h=fopen(szRomDat,"r");
  if (h==NULL) return 1;

  fgets(buffer,sizeof(buffer),h);
  fclose(h);
  if(buffer==NULL) return 1;

  wsprintf(label, "FBA%sROMS", szAppBurnVer);
  if((buffPos=LabelCheck(buffer, label))==NULL) return 1;
  for(i=0; i<MAX_GAMES; i++)
  {
    if(*buffPos=='a') gameAv[i]=TRUE;
	else if(*buffPos=='n') gameAv[i]=FALSE;
	else break;

	buffPos++;
  }

  if(LabelCheck(buffPos, label)!=NULL) { avOk=TRUE; return 0; }

  return 1;
}


int QuitRomsScan()
{
	int i;

	BzipClose();
	for (i=0;i<BZIP_MAX*4;i++)
	{
        // Free the names of each pathnames
        if (szRomName[i]!=NULL) free(szRomName[i]); // Free the strings
        szRomName[i]=NULL; szBzipName[i]=NULL; // Blank BZip list
	}
	nBurnDrvSelect=nOldSelect;
	nOldSelect=0;
	bRescanRoms=FALSE;
	hScanThread=NULL;
    dwScanThreadId=0;
	if(avOk) WriteGameAvb();

	return 1;
}


DWORD WINAPI AnalyzingRoms(LPVOID lpParam)
{
  (void)lpParam;
  int i=0, j=0;
  unsigned int z=0;
  char *myRomPath[4];

  memset(&szRomName,0,sizeof(szRomName));

  myRomPath[0] = szAppRomPath1;
  myRomPath[1] = szAppRomPath2;
  myRomPath[2] = szAppRomPath3;
  myRomPath[3] = szAppRomPath4;


  for(z=0; z<nBurnDrvCount; z++)
  {
	  nBurnDrvSelect=z;
	  SendDlgItemMessage(hRomsDlg, IDC_WAIT_PROG, PBM_STEPIT, 0, 0);

	  for (i=0;i<BZIP_MAX;i++)
	  {
	      char *szName=NULL; int nRet=0; int nStrLen[4]={0,0,0,0};

          nRet=BurnDrvGetZipName(&szName,i);
          if (nRet!=0) break;

	      for (j=0;j<=3;j++)
		  {
		     nStrLen[j]=strlen(szName)+strlen(myRomPath[j]);
		     szRomName[i*4+j]=(char *)malloc(nStrLen[j]+1); if (szRomName[i*4+j]==NULL) continue;
		     sprintf (szRomName[i*4+j],"%s%s",myRomPath[j],szName);
		     szBzipName[i*4+j]=szRomName[i*4+j];
		  }
	  }
      szBzipName[i*4]=NULL; // Mark end of zip name list

	  if(BzipOpen(TRUE)) gameAv[z]=0;
	  else gameAv[z]=1;

	  for (i=0;i<BZIP_MAX*4;i++)
	  {
        // Free the names of each pathnames
        if (szRomName[i]!=NULL) free(szRomName[i]); // Free the strings
        szRomName[i]=NULL; szBzipName[i]=NULL; // Blank BZip list
	  }

  }

  avOk=TRUE;
  bAvbOnly=1;
  MenuUpdate();

  PostMessage(hRomsDlg, WM_CLOSE, 0, 0);
  return 0;

}



static BOOL CALLBACK WaitProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
  (void)lParam;

  switch(Msg)
  {
	 case WM_INITDIALOG:
		 hRomsDlg=hDlg;
		 nOldSelect=nBurnDrvSelect;
		 bAvbOnly=0;
		 memset(gameAv,0,sizeof(gameAv));
		 SendDlgItemMessage(hDlg, IDC_WAIT_PROG, PBM_SETRANGE, 0, MAKELPARAM(0, nBurnDrvCount));
		 SendDlgItemMessage(hDlg, IDC_WAIT_PROG, PBM_SETSTEP, (WPARAM)1, 0);
		 hScanThread = CreateThread(NULL, 0, AnalyzingRoms, NULL, THREAD_TERMINATE, &dwScanThreadId);
		 break;

	 case WM_COMMAND:
		 if(LOWORD(wParam)==IDC_WAIT_CANC)
		 {
			 while(!TerminateThread(hScanThread, 0));
			 avOk=FALSE;
			 PostMessage(hDlg, WM_CLOSE, 0, 0);
		 }
		 break;

	 case WM_CLOSE:
		 QuitRomsScan();
		 EndDialog(hDlg,0);
		 hRomsDlg=NULL;

  }

  return 0;
}


int TestRomsCreate()
{
  if(CheckGameAvb() || bRescanRoms) DialogBox(hAppInst,MAKEINTRESOURCE(IDD_WAIT),hScrnWnd,WaitProc);
  return 1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////


