// Screen Window
#include "app.h"
#include "kailleraclient.h"
#include "chat.h"
#include "sshot.h"
#include <shellapi.h>

// Kill, Kll, Kill!!!
int DtosNewShortMsg(const char* pText, int nRGB = 0, int nDuration = 0, int nPiority = 0);

RECT SystemWorkArea = { 0, 0, 640, 480 };						 // Work area on the desktop

static char *szClass="Scrn"; // Window class name
HWND hScrnWnd=NULL; // Handle to the screen window

BOOL bAppInit=TRUE;
int bRescanRoms=FALSE;
static BOOL OnCreate(HWND, LPCREATESTRUCT);
static void OnActivateApp(HWND, BOOL, DWORD);
static void OnPaint(HWND);
static void OnClose(HWND);
static void OnDestroy(HWND);
static void OnCommand(HWND, int, HWND, UINT);
static void OnEnterMenuLoop(HWND, BOOL);
static void OnSize(HWND, UINT, int, int);
static void OnEnterIdle(HWND, UINT, HWND);
static void OnSetFocus(HWND, HWND);


static int WINAPI gameCallback(char *game, int, int)	//  int player, int numplayers
{
  extern int kNetGame;
  RECT recScrn;

  int found=-1;
  HWND hActive;

  for (unsigned int i=0;i<nBurnDrvCount;i++)
  {
    nBurnDrvSelect=i; // Switch to driver i
    if(!strcmp(BurnDrvText(1),game))
    {
      found=i;
      break;
    }
  }
  if(found==-1)
  {
    kailleraEndGame();
	return 1;
  }


  kNetGame=1;
  hActive=GetActiveWindow();
  MenuCreate(hScrnWnd, kNetGame);

  //Set size of panel;
  GetClientRect(hScrnWnd, &recScrn);
  MoveWindow(hPanelDlg,0,0,recScrn.right-recScrn.left,nPanelHeight,1);

  bCheatsAllowed=0;   // disable cheats during netplay
  AudSoundStop(); // stop while we load roms
  DrvInit(found);    // Init the game driver
  AudSoundPlay(); // restart sound
  SetFocus(hScrnWnd);
  RunMessageLoop();
  //ayeye
  DrvExit();
  //
  kNetGame=0;
  kailleraEndGame();
  bCheatsAllowed=1;  // reenable cheats netplay has ended
  MenuCreate(hScrnWnd, kNetGame);
  ScrnTitle();
  SetFocus(hActive);
  return 0;
}

static void WINAPI kChatCallback(char *nick, char *text)
{
  char tmp[512];
  wsprintf(tmp,"<%s> %s",nick,text);
  extern void DtosAddChat(const char *str);
  DtosAddChat(tmp);
}

static void WINAPI kDropCallback(char *nick, int playernb)
{
  char tmp[512];
  wsprintf(tmp,"* Player %i (%s) dropped from the current game.",playernb,nick);
  extern void DtosAddChat(const char *str);
  DtosAddChat(tmp);
}

void MenuLoadGame()
{
	CreateArcaderesItem();
	EnableMenuItem(hMenu, MENU_QUIT,  MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_INPUT, MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_PAUSE, MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_DIPSW, MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_ENABLECHEAT, MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_SAVESTATE, MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_LOADSTATE, MF_ENABLED|MF_BYCOMMAND);
    EnableMenuItem(hMenu, MENU_SPRMSK, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_FRAMES, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_11025,  MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_22050,  MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_44100,  MF_GRAYED|MF_BYCOMMAND);
}

void MenuQuitGame()
{
	bAltPause=0;
	CreateArcaderesItem();
	EnableMenuItem(hMenu, MENU_QUIT,  MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_INPUT, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_PAUSE, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_DIPSW, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_ENABLECHEAT, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_SAVESTATE, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_LOADSTATE, MF_GRAYED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_SPRMSK, MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_FRAMES, MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_11025,  MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_22050,  MF_ENABLED|MF_BYCOMMAND);
	EnableMenuItem(hMenu, MENU_44100,  MF_ENABLED|MF_BYCOMMAND);

}

static LRESULT CALLBACK ScrnProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
  switch (Msg)
  {
      HANDLE_MSG (hWnd, WM_CREATE       , OnCreate       );
	  HANDLE_MSG (hWnd, WM_ACTIVATEAPP  , OnActivateApp  );
	  HANDLE_MSGB(hWnd, WM_PAINT        , OnPaint        );
	  HANDLE_MSG (hWnd, WM_CLOSE        , OnClose        );
      HANDLE_MSG (hWnd, WM_DESTROY      , OnDestroy      );
      HANDLE_MSG (hWnd, WM_COMMAND      , OnCommand      );
	  HANDLE_MSGT(hWnd, WM_ENTERMENULOOP, OnEnterMenuLoop);
	  HANDLE_MSG (hWnd, WM_SIZE         , OnSize         );
      HANDLE_MSG (hWnd, WM_ENTERIDLE    , OnEnterIdle    );
      HANDLE_MSG (hWnd, WM_SETFOCUS     , OnSetFocus     );
  }

  return DefWindowProc(hWnd,Msg,wParam,lParam);
}

static BOOL OnCreate(HWND, LPCREATESTRUCT)	// HWND hwnd, LPCREATESTRUCT lpCreateStruct
{
	return TRUE;
}

static void OnActivateApp(HWND hwnd, BOOL fActivate, DWORD dwThreadId)
{
	(void)hwnd; (void)dwThreadId;
    if(!kNetGame && bAutoPause && !bAltPause && hInpdDlg==NULL && hInpCheatDlg==NULL && hInpDIPSWDlg==NULL)
		bRunPause = fActivate? 0:1;
}

static void OnPaint(HWND hwnd)
{
	(void)hwnd;
    VidPaint(1);  // paint and validate
}

static void OnClose(HWND hwnd)
{
	(void)hwnd;
    PostQuitMessage(0);  // Quit the program if the window is closed
}

static void OnDestroy(HWND hwnd)
{
	(void)hwnd;
    VidExit(); // Stop using video with the Window
    hScrnWnd=NULL; // Make sure handle is not used again
}

static void OnCommand(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
	(void)hDlg; (void)hwndCtl; (void)codeNotify;
	int n;
	unsigned int nOldDrvSelect;
	static char tmpver[256];
    static char gameList[8182];
	static char buffer[MAX_PATH];
	char *useFile[3]={ "fba.chm", "readme.txt", "whatsnew.txt" };
	char *useProg[2]={ "hh.exe" , "notepad.exe"};
    char *p=gameList;
	FILE *fp;
    kailleraInfos ki;

	switch(id){

	   case MENU_LOAD: {
		 static bool bLoading = 0;

		 if(kNetGame || nVidFullscreen || bLoading) return;
		 bLoading = 1;
		 AudSoundStop();			// Stop while the dialog is active or we're loading ROMs

		 n=SelDialog();			// Bring up select dialog to pick a driver

         if (n>=0)
		 {
			DrvInit(n);			// Init the game driver
			MenuLoadGame();
			bAltPause = 0;
			AudSoundPlay();		// Restart sound
			bLoading = 0;
			break;
		 }

         AudSoundPlay();			// Restart sound
		 bLoading = 0;
		 return;
	   }

	   case MENU_QUIT:
         if(bDrvOkay!=0)
		 {
		   DrvExit();
		   ScrnTitle();
		   MenuQuitGame();
		 }
		 break;

	   case MENU_EXIT:
         PostQuitMessage(0);
		 return;

	   case MENU_PAUSE:
		 if(bDrvOkay!=0) { bRunPause=!bRunPause; bAltPause=!bAltPause;}
         break;

	   case MENU_INPUT:
		 if(nVidFullscreen) return;
		 InpdCreate();
		 return;

	   case MENU_DEFINP:
		 DefInpCreate();
		 return;

	   case MENU_LOADSTATE:
         StatedLoad();
		 return;

	   case MENU_SAVESTATE:
		 StatedSave();
		 return;

	   case MENU_ALLRAM:
		 bDrvSaveAll=!bDrvSaveAll;
		 break;

	   case MENU_NOSTRETCH:
	 	 bVidCorrectAspect = 0;
		 bDtoStretch = 0;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_STRETCH:
		 bDtoStretch = -1;
		 if (bDtoStretch) {
		 	bVidCorrectAspect = 0;
		 }
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_ASPECT:
		 bVidCorrectAspect = -1;
		 if (bVidCorrectAspect) {
			bDtoStretch = 0;
		 }
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_TRIPLE:
         bDtoTripleBuffer=!bDtoTripleBuffer;
		 break;

	   case MENU_NORMAL:
		 bVidScanlines = 0;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_SCAN:
		 bVidScanlines = 1;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_SCAN50:
		 bVidScanHalf =! bVidScanHalf;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_FLICKER:
         bVidScanDelay =! bVidScanDelay;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_RES_ARCADE:
		 bVidArcaderes = !bVidArcaderes;
		 break;

	   case MENU_RES_1:
		 nVidWidth=VidPreset[0].nWidth; nVidHeight=VidPreset[0].nHeight;
		 bVidArcaderes = false;
		 break;

	   case MENU_RES_2:
		 nVidWidth=VidPreset[1].nWidth; nVidHeight=VidPreset[1].nHeight;
		 bVidArcaderes = false;
		 break;

	   case MENU_RES_3:
		 nVidWidth=VidPreset[2].nWidth; nVidHeight=VidPreset[2].nHeight;
		 bVidArcaderes = false;
		 break;

	   case MENU_RES_4:
		 nVidWidth=VidPreset[3].nWidth; nVidHeight=VidPreset[3].nHeight;
		 bVidArcaderes = false;
		 break;

	   case MENU_RES_OTHER:
		 bVidArcaderes = false;
		 ResCreate();
		 break;

       case MENU_8:
         nVidDepth=8;
		 break;

	   case MENU_16:
         nVidDepth=16;
		 break;

	   case MENU_24:
         nVidDepth=24;
		 break;

	   case MENU_32:
         nVidDepth=32;
		 break;

	   case MENU_GAMMA_DO:
		 bDoGamma = !bDoGamma;
		 SetBurnHighCol(GetDisplayDepth());
		 if (bDrvOkay) {
		   BurnRecalcPal();
		   VidRedraw();
		 }
		 break;

	   case MENU_GAMMA_DARKER:
		 nGamma = (float)1.25;
		 ComputeGammaLUT();
		 bDoGamma = 1;
		 SetBurnHighCol(GetDisplayDepth());
		 if (bDrvOkay) {
		   BurnRecalcPal();
		   VidRedraw();
		 }
		 break;

	   case MENU_GAMMA_LIGHTER:
		 nGamma = (float)0.80;
		 ComputeGammaLUT();
		 bDoGamma = 1;
		 SetBurnHighCol(GetDisplayDepth());
		 if (bDrvOkay) {
		   BurnRecalcPal();
		   VidRedraw();
		 }
		 break;

	   case MENU_GAMMA_OTHER: {
		 float nOldGamma = nGamma;
		 bDoGamma = 1;
		 SetBurnHighCol(GetDisplayDepth());
		 if (bDrvOkay) {
		   BurnRecalcPal();
		 }
		 GammaDialog();
		 if (nGamma == (float)1.0) {
		   nGamma = nOldGamma;
		   bDoGamma = 0;
		   SetBurnHighCol(GetDisplayDepth());
		   if (bDrvOkay) {
		     BurnRecalcPal();
		   }
		 } else {
		   bDoGamma = 1;
		   ComputeGammaLUT();
		   if (bDrvOkay) {
		     BurnRecalcPal();
		   }
		 }
		 break;
	   }

	   case MENU_SPRMSK:
		 nBurnMask = !nBurnMask;
		 break;

	   case MENU_FULL:
		 if (bDrvOkay) {
			 nVidFullscreen =! nVidFullscreen;
			 PostMessage(NULL, WM_APP + 0, 0, 0);
		 }
		 return; // restart video

	   case MENU_MEMAUTO:
		 nUseSysMemory = -1;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_VIDEOMEM:
		 nUseSysMemory = 0;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_SYSMEM:
         nUseSysMemory = 1;
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_SOUNDCODE:
		 nBurnSoundChoice^=1;
		 break;

	   case MENU_MUSICCODE:
         nBurnSoundChoice^=2;;
		 break;

	   case MENU_11025:
		 nDSoundSamRate=11025;
		 break;

	   case MENU_22050:
		 nDSoundSamRate=22050;
		 break;

	   case MENU_44100:
		 nDSoundSamRate=44100;
		 break;

	   case MENU_FRAMES:
		 NumDialCreate(0);
		 return;

	   case MENU_BASS:
         bAppBassFilter=!bAppBassFilter;
		 break;

	   case MENU_AUTOPAUSE:
         bAutoPause=!bAutoPause;
		 break;

	   case MENU_PRIORITY_REALTIME:
		 nAppThreadPriority = THREAD_PRIORITY_TIME_CRITICAL;
  		 SetThreadPriority(GetCurrentThread(),nAppThreadPriority);
		 break;
	   case MENU_PRIORITY_HIGH:
		 nAppThreadPriority = THREAD_PRIORITY_HIGHEST;
  		 SetThreadPriority(GetCurrentThread(),nAppThreadPriority);
		 break;
	   case MENU_PRIORITY_ABOVE_NORMAL:
		 nAppThreadPriority = THREAD_PRIORITY_ABOVE_NORMAL;
  		 SetThreadPriority(GetCurrentThread(),nAppThreadPriority);
		 break;
	   case MENU_PRIORITY_NORMAL:
		 nAppThreadPriority = THREAD_PRIORITY_NORMAL;
  		 SetThreadPriority(GetCurrentThread(),nAppThreadPriority);
		 break;
	   case MENU_PRIORITY_BELOW_NORMAL:
		 nAppThreadPriority = THREAD_PRIORITY_BELOW_NORMAL;
  		 SetThreadPriority(GetCurrentThread(),nAppThreadPriority);
	     break;
	   case MENU_PRIORITY_LOW:
		 nAppThreadPriority = THREAD_PRIORITY_LOWEST;
  		 SetThreadPriority(GetCurrentThread(),nAppThreadPriority);
		 break;

	   case MENU_DIPSW:
         InpDIPSWCreate();
		 break;

	   case ID_MISC_ROMSDIR:
		 RomsDirCreate();
		 return;

	   case MENU_RESCAN:
		 bRescanRoms=TRUE;
		 TestRomsCreate();
		 break;

	   case MENU_CLRMAME_PRO:
		 write_datfile(0);
		 return;

	   case MENU_ROMCENTER:
		 write_datfile(1);
		 return;

	   case MENU_ENABLECHEAT:
		 InpCheatCreate();
         break;

	   case MENU_CHFREQ:
		 NumDialCreate(1);
		 return;

	   case MENU_SAVESET:
		 ConfigAppSave();
		 return;

	   case MENU_LOADSET:
		 ConfigAppLoad();
		 PostMessage(NULL, WM_APP + 0, 0, 0);
		 break;

	   case MENU_STARTNET:
		 if(bDrvOkay!=0)
		 {
			 DrvExit();
			 ScrnTitle();
			 MenuQuitGame();
		 }
         EnableMenuItem(hMenu, MENU_STARTNET, MF_GRAYED|MF_BYCOMMAND);

         sprintf (tmpver, APP_TITLE " v%.20s",szAppBurnVer);

		 nOldDrvSelect=nBurnDrvSelect;

		 //Chat
		 strcpy(p,"*Chat (not game)");
         p+=strlen(p)+1;

         // Add all the driver names to the list
         for (n=0;n<(int)nBurnDrvCount;n++)
         {
			 //ayeye
             if(avOk && !gameAv[n]) continue;
			 nBurnDrvSelect=n; // Switch to driver i
             strcpy(p,BurnDrvText(1));
             p+=strlen(p)+1;
         }
         *p++=0;
         *p++=0;

		 nBurnDrvSelect=nOldDrvSelect;

         ki.appName=tmpver;
         ki.gameList=gameList;
         ki.gameCallback=&gameCallback;
         ki.chatReceivedCallback=&kChatCallback;
         ki.clientDroppedCallback=&kDropCallback;
         ki.moreInfosCallback=NULL;

         kailleraSetInfos(&ki);

         kailleraSelectServerDialog(NULL/*hDlg*/);

         EnableMenuItem(hMenu, MENU_STARTNET, MF_ENABLED|MF_BYCOMMAND);
         break;

	   case MENU_ABOUT:
		 AboutCreate();
		 return;

	   case MENU_CONTENTS:
		 n=0;
		 fp=fopen(useFile[n], "r");
		 if(fp==NULL)
		 {
		   n=1;
		   fp=fopen(useFile[n], "r");
		   if(fp==NULL) return;
		 }
		 fclose(fp);

		 GetCurrentDirectory(sizeof(buffer), buffer);
		 ShellExecute(NULL, "open", useProg[n], useFile[n], buffer, SW_SHOWNORMAL);
		 return;

	   case MENU_WHATSNEW:
		 fp=fopen(useFile[2], "r");
		 if(fp==NULL) return;

		 fclose(fp);
         GetCurrentDirectory(sizeof(buffer), buffer);
		 ShellExecute(NULL, "open", useProg[1], useFile[2], buffer, SW_SHOWNORMAL);
		 return;

	   case MENU_SAVESNAP:
		   char tmpmsg[15];
		   int status;

		   if(bDrvOkay!=0)
		   {
			   status=DoScreenShot();
			   if (!status)
			   {
				   strcpy(tmpmsg,"PNG Saved");
				   wsprintf(tmpmsg, tmpmsg);
				   DtosNewShortMsg(tmpmsg);
			   }
			   else
			   {
				   strcpy(tmpmsg,"PNG Error: %1d");
				   wsprintf(tmpmsg, tmpmsg, status);
				   DtosNewShortMsg(tmpmsg, 0xFF3F3F);
			   }
		   }
		   return;
	   case MENU_SNAPFACT:
		SFactdCreate();
		   return;

	}

	MenuUpdate();
}

static void OnEnterMenuLoop(HWND hWnd, BOOL fIsTrackPopupMenu)
{
	(void)hWnd;	(void)fIsTrackPopupMenu;

	if(!kNetGame && !bAltPause && bDSoundOkay) AudBlankSound();

}

static void OnSize(HWND hwnd, UINT state, int cx, int cy)
{
	(void)hwnd; (void)state; (void)cy;

    if(kNetGame) MoveWindow(hPanelDlg,0,0,cx,nPanelHeight,1); // Size the panel
}

static void OnEnterIdle(HWND hwnd, UINT source, HWND hwndSource)
{
	(void)hwnd; (void)source; (void)hwndSource;
	MSG Message;

    // Modeless dialog is idle
    while (kNetGame && !PeekMessage(&Message,NULL,0,0,PM_NOREMOVE)) RunIdle();
}

static void OnSetFocus(HWND hwnd, HWND hwndOldFocus)
{
	(void)hwnd; (void)hwndOldFocus;

	if(bAppInit) { bAppInit=FALSE; TestRomsCreate();}
}

static HBRUSH hScrnBrush=NULL;

static int ScrnRegister()
{
  ATOM Atom=0;
  WNDCLASSEX WndClassEx;
  // Register the window class
  memset(&WndClassEx,0,sizeof(WndClassEx)); // Init structure to all zeros
  WndClassEx.cbSize=sizeof(WndClassEx);
  WndClassEx.style=CS_HREDRAW|CS_VREDRAW;
  WndClassEx.lpfnWndProc=ScrnProc;
  WndClassEx.hInstance=hAppInst;
  WndClassEx.hIcon=LoadIcon(hAppInst,MAKEINTRESOURCE(IDI_APP));
  WndClassEx.hCursor=LoadCursor(NULL,IDC_ARROW);

  hScrnBrush=CreateSolidBrush(0);
  WndClassEx.hbrBackground=hScrnBrush;
  WndClassEx.lpszClassName=szClass;
  // Register the window class with the above information:
  Atom=RegisterClassEx(&WndClassEx); if (Atom==0) return 1;
  return 0;
}

int ScrnSize()
{
	int x,y,w,h,ew,eh;
	int nBmapWidth=320,nBmapHeight=224;
	int nMaxSize;
	if (hScrnWnd==NULL) return 1;
	if (bDrvOkay) {
		BurnDrvGetScreen(&nBmapWidth, &nBmapHeight);
	}

	SystemParametersInfo(SPI_GETWORKAREA,0,&SystemWorkArea,0); // Find the size of the visible WorkArea

	if (nVidFullscreen) return 1;

	if (nBmapWidth <=0) return 1;
	if (nBmapHeight<=0) return 1;

	if (nBmapWidth < nBmapHeight) {
		if (SystemWorkArea.bottom - SystemWorkArea.top <= 600) {
			nMaxSize = 1;
		} else {
			if (SystemWorkArea.bottom - SystemWorkArea.top <= 960) {
				nMaxSize = 2;
			} else {
				nMaxSize = 3;
			}
		}
	} else {
		if (SystemWorkArea.right - SystemWorkArea.left <= 640) {
			nMaxSize = 1;
		} else {
			if (SystemWorkArea.right - SystemWorkArea.left <= 1152) {
				nMaxSize = 2;
			} else {
				nMaxSize = 3;
			}
		}
	}

	// Find the midpoint for the window
	x=SystemWorkArea.left  +SystemWorkArea.right; x/=2;
	y=SystemWorkArea.bottom+SystemWorkArea.top  ; y/=2;
	// Find the width and height
	w=SystemWorkArea.right -SystemWorkArea.left;
	h=SystemWorkArea.bottom-SystemWorkArea.top;

	// Find out how much space is taken up by the borders
	ew =GetSystemMetrics(SM_CXSIZEFRAME)<<1;
	eh =GetSystemMetrics(SM_CYSIZEFRAME)<<1;
	eh+=GetSystemMetrics(SM_CYCAPTION);
	eh+=nPanelHeight; // for panel

	w-=ew; h-=eh; // Subtract the border space

 	if (bVidCorrectAspect | bDtoStretch) {
		if (h > nBmapHeight * nMaxSize) {
			h = nBmapHeight * nMaxSize;
		}
		if (nBmapWidth < nBmapHeight) {
			if (w > h * 3 * (SystemWorkArea.bottom - SystemWorkArea.top) / 4 / (SystemWorkArea.right - SystemWorkArea.left)) {
				w = h * 3 * (SystemWorkArea.bottom - SystemWorkArea.top) / 4 / (SystemWorkArea.right - SystemWorkArea.left);
			}
		} else {
			if (w > h * 4 * (SystemWorkArea.right - SystemWorkArea.left)/ 3 / (SystemWorkArea.bottom - SystemWorkArea.top)) {
				w = h * 4 * (SystemWorkArea.right - SystemWorkArea.left)/ 3 / (SystemWorkArea.bottom - SystemWorkArea.top);
			}
		}
	} else {
		if (w > nBmapWidth * nMaxSize) {
			w = nBmapWidth * nMaxSize;
		}
		if (h >= nBmapHeight * nMaxSize) {
			h = nBmapHeight * nMaxSize;
		} else {
			if (h >= nBmapHeight) {
				h = nBmapHeight;
				w = nBmapWidth;
			}
		}
	}
	RECT rect = { 0, 0, w, h };
	if (!bDtoStretch) {
		IntegerScale(&rect, nBmapWidth, nBmapHeight);
	}
	w = rect.right - rect.left + ew;
	h = rect.bottom - rect.top + eh;

  	x-=w/2; y-=h/2; // Re-add the border space
  	MoveWindow(hScrnWnd,x,y,w,h,1);
	MenuUpdate();
  	return 0;
}

int ScrnTitle()
{
  char szWinName[128]="";
  if (bDrvOkay)
  {
    // Create window title
    sprintf (szWinName,"%.70s - " APP_TITLE " v%.20s",BurnDrvText(1),szAppBurnVer);
  }
  else
  {
    sprintf (szWinName, APP_TITLE " v%.20s",szAppBurnVer); // Create window title
  }

  SetWindowText(hScrnWnd,szWinName);
  return 0;
}

// Init the screen window (create it)
int ScrnInit()
{
  if (ScrnRegister()!=0) return 1;

  hScrnWnd=CreateWindow(
    szClass,APP_TITLE, nVidFullscreen?WS_POPUP:WS_OVERLAPPEDWINDOW, // style of window
    0,0,0,0, // size of window
    NULL,NULL,hAppInst,NULL);
  if (hScrnWnd==NULL) { ScrnExit(); return 1; }

  ScrnSize();
  ScrnTitle();

  if (nVidFullscreen == 0)
  {
	MenuCreate(hScrnWnd, kNetGame);
	if(kNetGame) PanelShow(1);
  }

  return 0;
}

// Exit the screen window (destroy it)
int ScrnExit()
{
  if (hScrnWnd!=NULL) DestroyWindow(hScrnWnd);  hScrnWnd=NULL; // Ensure the window is destroyed
  UnregisterClass(szClass,hAppInst); // Unregister the scrn class
  if(hMenu!=NULL) DestroyMenu(hMenu); hMenu=NULL;
  DeleteObject(hScrnBrush); hScrnBrush=NULL;
  return 0;
}
