#ifndef HIPASS_INCLUDED
#define HIPASS_INCLUDED

#include <stdlib.h>
#include <stdio.h>

//#define FindMaxVol

class LowPass3
{
public:
	LowPass3(void);
	LowPass3(double Freq, double SampleRate, double Q, double Gain);
	~LowPass3(void);

	void Filter(short int *Buff, int Tam);
	void SetParam(double Freq, double SampleRate, double Q, double Gain);

private:
	int a0, a1, a2, b0, b1, b2;
	int i0, i1, i2, o0, o1, o2;

	int a0b, a1b, a2b, b0b, b1b, b2b;
	int o0b, o1b, o2b;

	// Yes, I know some of these are not used

#ifdef FindMaxVol
	int Min, Max;
#endif

};

#endif
